proc mc:thingtaken {id th} {
	global liv mcr todo
	
    foreach pl [array names liv] {
	    if {$mcr($pl) == $mcr($id)} {
		    set things ""
		    foreach pr [mc:modget $pl 13] {
			    if {[lindex $pr 0] == $th} {
				    set things [lappend things [lindex $pr 1]]
			    }
		    }
		    foreach dodo $todo($pl) {
    			if {[lindex $dodo 0] == "u" && [lsearch -exact $things [lindex $dodo 2]] != -1} {
	    			return 1
    			}
  			}
	    }
    }
    
    return 0
}

proc mc:thingtakenbyid {id th} {
	global liv mcr todo
	
    set things ""
    foreach pr [mc:modget $id 13] {
	    if {[lindex $pr 0] == $th} {
		    set things [lappend things [lindex $pr 1]]
	    }
    }
    foreach dodo $todo($id) {
		if {[lindex $dodo 0] == "u" && [lsearch -exact $things [lindex $dodo 2]] != -1} {
			return 1
		}
	}
    
    return 0
}

# !nostat  
proc mc:nostat {n uh h t} {
    global mcs mc cth nick botmoney

    set ee [tolower [ms:fl $n]]
    if {![mc:check $ee -]} { return } 

    set pay4nostat 1000
    if {[mc:modget $ee 11] < $pay4nostat} {
        mc:msg $n $cth(82na)
        return
    }
    mc:mod $ee 11 "-$pay4nostat"
    set botmoney [expr $botmoney + ($pay4nostat * 3 / 100)]

    if {[llength [lindex [mc:modget $ee 13] 0]] == 4} {
        putcmdlog "$ee![llength [lindex [mc:modget $ee 13] 0]]![lindex [mc:modget $ee 13] 0]"
        set tmvv ""
        foreach ee2 [mc:modget $ee 13] {
            set tmvv [lappend tmvv "[lreplace $ee2 2 2 0]"]
        }
        mc:modset $ee 13 $tmvv
        mc:modset $ee 25 0
    }

    set lev [mc:modget $ee 17]
    switch [mc:modget $ee 16] {
        w { set ss 10; set sl 8; set sv 6; set si 3; set sm 3;}
        m { set ss 3; set sl 3; set sv 6; set si 8; set sm 10;}
        p { set ss 3; set sl 3; set sv 6; set si 10; set sm 8;}
        l { set ss 3; set sl 8; set sv 6; set si 10; set sm 3;}
    }
    mc:modset $ee 4 $ss
    mc:modset $ee 5 $sl
    mc:modset $ee 6 $sm
    mc:modset $ee 7 $si
    mc:modset $ee 8 $sv
    mc:modset $ee 9 [expr 10 * $lev]
    mc:modset $ee 10 [expr 5 + [mc:modget $ee 17] + [mc:modget $ee 30]]

    putcmdlog " $ee - reset his stats."
    mc:msg $n [format $cth(82nb)][mc:gethark $ee]
    mc:msg $n [format $cth(82nc) $pay4nostat]
    mc:putfilelog "logs/$nick.nostat.[clock format [unixtime] -format "%d.%m.%Y"].log" $uh "$n - nostat"
    mc:notice $mc(notchan) "nostat: $ee"
}

#  dcc
proc mc:killdcc {n uh h t} {
  global mcnt mctp mctn mctnp

  set id [tolower [ms:fl $n]]
  if {![mc:check $id -]} { return }
  if {[info exists mcnt($id)]} {
	  if {[info exists mctp($mcnt($id))]} { unset mctp($mcnt($id)) }
	  if {[info exists mctn($mcnt($id))]} { unset mctn($mcnt($id)) }
	  if {[info exists mctnp($mcnt($id))]} { unset mctnp($mcnt($id)) }
	  set idx $mcnt($id)
	  unset mcnt($id)
	  killdcc $idx
  }
}

# weapon unrename
proc mc:munrename {n uh h t} {
  global cth mcs mc
	
  if {[llength $t] < 2} {
      mc:msg $n $cth(91a)
      return
  }
  set id [tolower [ms:fl [lindex $t 1]]]
  if {![info exists mcs($id)]} {
	  mc:msg $n [format $cth(75c) [lindex $t 1]]
	  return
  }
  mc:modset $id 34 0
  mc:msg $n [format $cth(91b) [ms:dfl [mc:nick $id]]]
  mc:notice $mc(notchan) "weapon_unrename: $n $id"
}

# weapon rename
proc mc:mrename {n uh h t} {
  global thi cth mcs mc

  if {[llength $t] < 4} {
      mc:msg $n $cth(90a)
      return
  }
  set id [tolower [ms:fl [lindex $t 1]]]
  if {![info exists mcs($id)]} {
	  mc:msg $n [format $cth(75c) [lindex $t 1]]
	  return
  }
  set wcode [tolower [lindex $t 2]]
  if {$wcode == "current"} {
	  foreach pp [mc:modget $id 13] {
		  if {[lindex $pp 1] == [mc:modget $id 25]} {
			  set wcode [lindex $pp 0]
		  }
	  }
  }
  if {[info exists thi($wcode)]} {
	  set t [split $t]
  	  regsub -all \\\[ $t "" t
  	  regsub -all \\\] $t "" t
  	  regsub -all \\\{ $t "" t
  	  regsub -all \\\} $t "" t
  	  regsub -all \\\^ $t "" t
      regsub -all \\\" $t "'" t
  	  regsub -all \\\\ $t "/" t
  	  set wtitle "*[mc:delstrips [string trim [join [lrange [ms:fl $t] 3 end]]]]*"
      mc:modset $id 34 "$wcode {$wtitle}"
      mc:msg $n [format $cth(90c) [mc:wget $wcode name] [ms:dfl [mc:nick $id]] $wtitle]
      mc:notice $mc(notchan) "weapon_rename: $n $id $wcode $wtitle"
  } else {
	  mc:msg $n $cth(90b)
  }
}

# wanna trade?
proc mc:auctionbid {n uh h t} {
  global cth auction mc
  
  set id [tolower [ms:fl $n]]
  if {![mc:check $id -]} { return }
  
  if {![array exists auction]} {
      mc:msg $n $cth(88f)
      return	  
  }
  if {$id == $auction(starter)} { return }
  if {[mc:modget $id 17] == 1 && [mc:modget $id 30] == 0} {
	  mc:msg $n $cth(88h)
	  return
  }
  if {[llength $t] != 3} {
      mc:msg $n $cth(88a)
      return
  }
  set bid [lindex $t 2]
  if {![isnumber $bid] || $bid <= 0 || $bid <= $auction(startprice) || $bid > [mc:modget $id 11] || ($auction(currentbid) != "-" && $bid <= $auction(currentbid))} {
      mc:msg $n $cth(88b)
      return
  }
  set auctbidstep "$auction(bidstep).0"
  if {($auction(currentbid) == "-" && [expr fmod([expr $bid - $auction(startprice)], $auctbidstep)] != 0) || ($auction(currentbid) != "-" &&  [expr fmod([expr $bid - $auction(currentbid)], $auctbidstep)] != 0)} {
      mc:msg $n [format $cth(88c) $auction(bidstep)]
      return
  }
  if {[expr [mc:realweight $id] + [mc:wget $auction(thing) weight]] > [mc:maxweight $id]} {
      mc:msg $n $cth(88g)
      return	  
  }
  if {![mc:checkin [mc:modget $id 16] [mc:wget $auction(thing) race]]} {
      mc:msg $n $cth(8b)
      return
  }  
  set auction(currentbid) $bid
  set auction(currentnck) $id
  set auction(totalbids) [expr $auction(totalbids) + 1]
  mc:msg $n [format $cth(88d) $bid [mc:wget $auction(thing) name]]
  mc:notice $mc(chan) [xformat2 $cth(88e) "{[mc:modget $id 21]}" "[ms:dfl [mc:nick $id]] $bid {[stripspec [mc:wget $auction(thing) name]]} [expr $bid + $auction(bidstep)]"]
}

proc mc:auctionadd {n uh h t} {
  global cth auction mc
  
  set id [tolower [ms:fl $n]]
  if {![mc:check $id -]} { return }

  if {[mc:modget $id 17] < 4 && [mc:modget $id 30] == 0} {
      mc:msg $n $cth(87f)
      return      
  }
  if {[llength $t] < 3} {
      mc:msg $n $cth(87b)
      return
  }
  if {[array exists auction]} {
      mc:msg $n [format $cth(87a) [ms:dfl [mc:nick $auction(starter)]] [mc:wget $auction(thing) name]]
      return
  }
  set thnumber [lindex $t 2]
  set startprice [lindex $t 3]
  set bidstep [lindex $t 4]
  if {![isnumber $thnumber] || ![isnumber $startprice] || ![isnumber $bidstep]} {
      mc:msg $n $cth(87b)
      return      
  }
  if {$thnumber == 0} {
      mc:msg $n $cth(87j)
      return
  }
  set tth ""
  foreach th [mc:modget $id 13] {
      if {[lindex $th 1] == $thnumber} {
          set tth $th
          break
      }
  }
  if {$tth == ""} {
      mc:msg $n [format $cth(87c) $thnumber]
      return
  }
  set thcode [lindex $tth 0]
  if {[mc:wget $thcode type] == "p" || [mc:wget $thcode type] == "raw"} {
      mc:msg $n $cth(87d)
      return      
  }
  if {[lindex $tth 2]} {
      mc:msg $n $cth(87e)
      return
  }
  if {[mc:wget $thcode price] <= 50} {
      mc:msg $n $cth(87o)
      return	  
  }
  if {$startprice >= [mc:wget $thcode price]} {
      mc:msg $n [format $cth(87g) [mc:wget $thcode price]]
      return      
  }
  if {[expr 2*$bidstep + $startprice] > [mc:wget $thcode price]} {
      mc:msg $n $cth(87h)
      return      
  }
  if {[mc:modget $id 38] >= 1} {
	  mc:msg $n $cth(87p)
	  return
  }
  set auction(starter) $id
  set auction(starttime) [clock seconds]
  set auction(thnumber) $thnumber
  set auction(thing) $thcode
  set auction(startprice) $startprice
  set auction(bidstep) $bidstep
  set auction(currentbid) "-"
  set auction(currentnck) "-"
  set auction(totalbids) 0
  mc:mod $id 38 1
  mc:msg $n [format $cth(87k) $startprice [mc:wget $thcode name] $bidstep]  
  mc:notice $mc(chan) [xformat2 $cth(87l) "{[mc:modget $id 21]}" "[ms:dfl [mc:nick $id]] $startprice {[stripspec [mc:wget $thcode name]]} $thcode $bidstep"]
  if {[mc:wget $thcode price] < 500} {
      utimer 300 { mc:auctionkill }
      utimer 80 { mc:auctionanounce }
  } elseif {[mc:wget $thcode price] < 2500} {
      utimer 500 { mc:auctionkill }
      utimer 100 { mc:auctionanounce }
  } else {
      utimer 800 { mc:auctionkill }
      utimer 180 { mc:auctionanounce }
  }
}

proc mc:auctionstop {n uh h t} {
  global cth auction mc mcs
  
  set id [tolower [ms:fl $n]]
  if {![array exists auction]} { 
	  mc:msg $n $cth(88f)
	  return
  }  
  if {$id != $auction(starter) && ![mc:isfriend $h]} { return }
  if {[expr [clock seconds] - $auction(starttime)] < 100} { return }
  foreach e [utimers] {
     if {[string match "*mc:auctionkill*" $e] || [string match "*mc:auctionanounce*" $e]} {
        killutimer [lindex $e 2]
     }
  }
  if {$auction(currentbid) == "-"} {
	  mc:notice $mc(chan) [format $cth(87n) [mc:wget $auction(thing) name]]
	  unset auction
	  return
  }
  if {![info exists mcs($auction(starter))] || ![info exists mcs($auction(currentnck))]} { 
	  unset auction
	  return 
  }
  set pr1 [mc:modget $auction(starter) 13]
  set pr2 [mc:modget $auction(currentnck) 13]
  set prr1 ""
  set prr2 ""
  set ison 0
  set cl ""
  foreach pp $pr1 {
      if {[lindex $pp 1] == $auction(thnumber)} {
          set ison 1
          set cl [lindex $pp 3]
      } else {
          set prr1 [lappend prr1 $pp]
      }
  }
  if {$ison} {
	  mc:modset $auction(starter) 13 $prr1
  } else {
	  unset auction
	  return
  }
  foreach pp [mc:modget $auction(currentnck) 13] {
     set tarr([lindex $pp 1]) 1
  }
  set nn 0
  for {set i 0} {$i <= [array size tarr]} {incr i} {
     if {![info exist tarr($i)]} {
        set nn $i
        break
     }
  }  
  set oo [mc:modget $auction(currentnck) 13]
  mc:modset $auction(currentnck) 13 [lappend oo "$auction(thing) $nn 0 {$cl}"]
  mc:mod $auction(currentnck) 11 -$auction(currentbid)
  mc:mod $auction(starter) 11 $auction(currentbid)
  mc:msg [ms:dfl [mc:nick $auction(currentnck)]] [format $cth(89a) $auction(currentbid) [mc:wget $auction(thing) name]]  
  mc:notice $mc(chan) [format $cth(89b) [mc:wget $auction(thing) name] [expr (([clock seconds] - $auction(starttime)) / 60) + 1] [ms:dfl [mc:nick $auction(currentnck)]] $auction(currentbid) $auction(totalbids)]  
  unset auction
}

proc mc:auctionkill {} {
  global cth auction mc mcs
  
  if {![array exists auction]} { return }
  foreach e [utimers] {
     if {[string match "*mc:auctionkill*" $e] || [string match "*mc:auctionanounce*" $e]} {
        killutimer [lindex $e 2]
     }
  }  
  if {$auction(currentbid) == "-"} {
	  mc:notice $mc(chan) [format $cth(87n) [mc:wget $auction(thing) name]]
	  unset auction
	  return
  }
  if {![info exists mcs($auction(starter))] || ![info exists mcs($auction(currentnck))]} { 
	  unset auction
	  return 
  }
  set pr1 [mc:modget $auction(starter) 13]
  set pr2 [mc:modget $auction(currentnck) 13]
  set prr1 ""
  set prr2 ""
  set ison 0
  set cl ""  
  foreach pp $pr1 {
      if {[lindex $pp 1] == $auction(thnumber)} {
	      set cl [lindex $pp 3]
          set ison 1
      } else {
          set prr1 [lappend prr1 $pp]
      }
  }
  if {$ison} {
	  mc:modset $auction(starter) 13 $prr1
  } else {
	  unset auction
	  return
  }
  foreach pp [mc:modget $auction(currentnck) 13] {
     set tarr([lindex $pp 1]) 1
  }
  set nn 0
  for {set i 0} {$i <= [array size tarr]} {incr i} {
     if {![info exist tarr($i)]} {
        set nn $i
        break
     }
  }
  set oo [mc:modget $auction(currentnck) 13]
  mc:modset $auction(currentnck) 13 [lappend oo "$auction(thing) $nn 0 {$cl}"]
  mc:mod $auction(currentnck) 11 -$auction(currentbid)
  mc:mod $auction(starter) 11 $auction(currentbid)
  mc:msg [ms:dfl [mc:nick $auction(currentnck)]] [format $cth(89a) $auction(currentbid) [mc:wget $auction(thing) name]]  
  mc:notice $mc(chan) [format $cth(89b) [mc:wget $auction(thing) name] [expr (([clock seconds] - $auction(starttime)) / 60) + 1] [ms:dfl [mc:nick $auction(currentnck)]] $auction(currentbid) $auction(totalbids)]
  unset auction
}

proc mc:auctionanounce {} {
  global cth auction mc
  
  if {![array exists auction]} { return }
  
  if {$auction(currentnck) == "-"} {
      mc:notice $mc(chan) [format $cth(87m) [ms:dfl [mc:nick $auction(starter)]] $auction(startprice) [mc:wget $auction(thing) name] $auction(thing) $auction(bidstep)]
  } else {
      mc:notice $mc(chan) [format $cth(87m_) [ms:dfl [mc:nick $auction(starter)]] $auction(startprice) [mc:wget $auction(thing) name] $auction(thing) $auction(bidstep) [ms:dfl [mc:nick $auction(currentnck)]] $auction(currentbid)]
  }
  if {[mc:wget $auction(thing) price] < 500} {
      utimer 96 { mc:auctionanounce }
  } elseif {[mc:wget $auction(thing) price] < 2500} {
      utimer 90 { mc:auctionanounce }
  } else {
      utimer 100 { mc:auctionanounce }
  }
}

#   ""
proc mc:clonelist {n uh h t} {
  global anicks cth mc

  if {![info exists anicks] || [llength $anicks] < 1} {
      mc:msg $n $cth(82gk)
      return
  }
  mc:msg $n $cth(82gl_)
  putcmdlog "$cth(82gl)"
  set i 1
  foreach clpar $anicks {
      putcmdlog "[format $cth(82gm) $i [ms:dfl [lindex $clpar 0]] [ms:dfl [lindex $clpar 1]]]"
      incr i
  }
}

#    ()
proc mc:acceptanick {n uh h t} {
  global anicks cth mc

  if {[llength $t] < 2} {
      mc:msg $n $cth(82gc)
      return
  }
  set id [tolower [ms:fl [lindex $t 1]]]
  if {[llength $t] > 2} {
      set host [tolower [ms:fl [lindex $t 2]]]
  } else {
      set host [tolower [ms:fl [getchanhost [lindex $t 1] $mc(chan)]]]      
  }
  regsub -all "^.*@" $host "" host
  if {[string trim $host] == ""} {
      mc:msg $n [format $cth(82gf) [lindex $t 1]]
      return
  }
  if {[mc:isonanicklist $id $host] || [mc:isonanicklist "*" $host] || [mc:isonanicklist $id "*"]} {
      mc:msg $n [format $cth(82gd) [lindex $t 1] $host]
      return
  }
  set anicks [lappend anicks "$id $host"]
  mc:msg $n [format $cth(82ge) [lindex $t 1] $host]
  if {[onchan [ms:dfl $id] $mc(chan)]} {
     mc:msg [ms:dfl $id] [format $cth(82gea) $host]
  }
  mc:notice $mc(notchan) "notclone: $n $id $host"
}

#    ()
proc mc:deleteanick {n uh h t} {
  global anicks cth mc

  if {[llength $t] < 2} {
      mc:msg $n $cth(82gg)
      return
  }
  if {[isnumber [lindex $t 1]]} {
      set num2delete [expr [lindex $t 1] - 1]
      if {$num2delete > [llength $anicks] || $num2delete < 0} {
         mc:msg $n [format $cth(82gn) [lindex $t 1]]
         return          
      }
      set excnic [lindex $anicks $num2delete]
      set anicks [lreplace $anicks $num2delete $num2delete]
      mc:msg $n [format $cth(82gj) [ms:dfl [lindex $excnic 0]] [ms:dfl [lindex $excnic 1]]]
      return
  }
  set id [tolower [ms:fl [lindex $t 1]]]
  if {[llength $t] > 2} {
      set host [tolower [ms:fl [lindex $t 2]]]
  } else {
      set host [tolower [ms:fl [getchanhost [lindex $t 1] $mc(chan)]]]
  }
  regsub -all "^.*@" $host "" host
  if {[string trim $host] == ""} {
      mc:msg $n [format $cth(82gf) [lindex $t 1]]
      return
  }
  if {![mc:isonanicklist $id $host]} {
      mc:msg $n [format $cth(82gh) [lindex $t 1] $host]
      return
  }
  while {[lsearch -exact $anicks "$id $host"] != -1} {
      set ind [lsearch -exact $anicks "$id $host"]
      set anicks [lreplace $anicks $ind $ind]
  }
  mc:msg $n [format $cth(82gj) [lindex $t 1] $host]
  mc:notice $mc(notchan) "clone: $n $id $host"
}

#     $n   $h
proc mc:isonanicklist {n h} {
  global anicks
  
  if {![info exists anicks]} { return 0 }
  set n [tolower $n]
  foreach an $anicks {
     if {[llength $an] != 2} { continue }
     if {[lindex $an 0] == $n || [lindex $an 0] == "*"} {
         if {[string match -nocase [lindex $an 1] $h]} { return 1 }
         if {[lindex $an 1] == [tolower $h] || [lindex $an 1] == "*"} { return 1 }
     }
  }
  return 0
}
#   
proc mc:mlockedchars {n uh h t} {
  global mcs cth
  
  set out ""
  foreach id [array names mcs] {
	  set passwd [mc:modget $id 1]
	  if {[regexp -all -nocase -- "(-blocked-)$" $passwd]} {
		  set out [lappend out [ms:dfl [mc:nick $id]]]
	  }  	  
  }
  if {$out == ""} {
	  mc:msg $n [format $cth(82be) "< >"]
  } else {
	  mc:msg $n [format $cth(82be) [join $out ", "]]
  }
}

#  
proc mc:mlockchar {n uh h t} {
  global mcs cth mc liv ghost todo prcold killed prc
  global mcnt mctn mctp mctmp
  
  if {[llength $t] < 2} {
      mc:msg $n $cth(82aa)
      return
  }
  set id [tolower [ms:fl [lindex $t 1]]]
  if {![info exists mcs($id)]} {
      mc:msg $n [format $cth(82ac) [lindex $t 1]]
      return
  }
  set passwd [mc:modget $id 1]
  if {[regexp -all -nocase -- "(-blocked-)$" $passwd]} {
      mc:msg $n [format $cth(82bd) [lindex $t 1]]
      return
  }
  if {[info exists mc(ident)]} {
	  set identindex [lsearch -exact $mc(ident) $id]
	  if {$identindex != -1} {
	      set mc(ident) [lreplace $mc(ident) $identindex $identindex]
	  }
  }
  mc:modset $id 1 "[mc:modget $id 1]-blocked-"
  if {[array exists mcnt] && [info exists mcnt($id)] && [valididx $mcnt($id)]} {
     if {[array exists mctn] && [info exists mctn($mcnt($id))]} { unset mctn($mcnt($id)) }
     if {[array exists mctp] && [info exists mctp($mcnt($id))]} { unset mctp($mcnt($id)) }
     if {[array exists mctnp] && [info exists mctnp($mcnt($id))]} { unset mctnp($mcnt($id)) }
     killdcc $mcnt($id)
     unset mcnt($id)
  }
  if {$mc(phase) == 0} {
     mc:punreg [mc:modget $id 0] 0 0 $mc(chan) "!unreg"
  } elseif {[info exists liv($id)] || [info exists ghost($id)]} {
     set todo($id) [lappend todo($id) "r"]
     set prcold($id) $prc($id)
     set prc($id) 0
     set killed($id) 1
     if {[info exists ghost($id)]} { unset ghost($id) }
     utimer 5 { mc:checkend }
  }
  mc:msg $n [format $cth(82ad) [lindex $t 1]]
  mc:notice $mc(notchan) "charblock: $n $id"
}

#  
proc mc:munlockchar {n uh h t} {
  global cth mcs mc
  
  if {[llength $t] < 2} {
      mc:msg $n $cth(82ba)
      return
  }
  set id [tolower [ms:fl [lindex $t 1]]]
  if {![info exists mcs($id)]} {
      mc:msg $n [format $cth(82ac) [lindex $t 1]]
      return
  }
  set passwd [mc:modget $id 1]
  if {![regexp -all -nocase -- "(-blocked-)$" $passwd]} {
      mc:msg $n [format $cth(82bb) [lindex $t 1]]
      return
  }
  set passwd [string range $passwd 0 [expr [string last "-blocked-" [mc:modget $id 1]] - 1]]
  if {[string length [string trim $passwd]] > 0} {
      mc:modset $id 1 [string trim $passwd]
      mc:msg $n [format $cth(82bc) [lindex $t 1]]
      mc:notice $mc(notchan) "charunblock: $n $id"
  }  
}

#  
proc mc:mendround {n uh h c t} {
  global mc liv cth
  
#  if {![isop $n $mc(chan)]} { return }
  
# if {$mc(phase) != 1} {
#     mc:notice $n $cth(82da)
#     return
# }
  mc:pendround $n
}
proc mc:pendround {stopnick} {
  global mc liv cth prc ct
  global oldtodo todo endround
  
  foreach id [array names liv] {
    if {$prc($id) != 0} {
      set prc($id) 0
    }
  }
  cleartimers
  mc:say [format $ct(29b) $mc(rounddelay)]
  if {[array exist oldtodo]} { unset oldtodo }
  foreach id [array names liv] {
     set oldtodo($id) $todo($id)
  }
  set endround 1
  mc:say [format $cth(82db) $stopnick]
  bots:say $stopnick "!endround"
  utimer $mc(rounddelay) { mc:roundend }
}

#  
proc mc:mendgame {n uh h c t} {
  global mc liv cth
  
#  if {![isop $n $mc(chan)]} { return }
  
  if {$mc(phase) == 0} {
      mc:notice $n $cth(82ca)
      return
  }
  mc:pendgame $n
}

proc mc:pendgame {stopnick} {
  global mc mce mcr mco mcc oldtodo ghost uhosts killed victim victims poifail liv
  global te nnick cth noreg ct mcs uhosts

  bots:say $stopnick "!endgame"
  cleartimers
  if {![mc:moderated]} {
      if {$mc(twobots)} {
         mc:putslave moderate $stopnick
      } else {
         pushmode $mc(chan) +m
      }
  }
  foreach n [chanlist $mc(chan)] {
    if {[isvoice $n $mc(chan)]} {
       if {$mc(twobots)} {
          mc:putslave devoice $n
          # mc:putslave rawcmd_fast "MODE $mc(chan) -v $n"
       } else {
          pushmode $mc(chan) -v $n
       }
    }
  }
  if {![array exists te]} {
      set te(0) ""
  }
  if {[array exists mcr]} {
     foreach e [array names mcr] {
        if {![info exists mcs($e)]} { continue }
        if {![info exists te($e)]} { set te($e) 0 }
        mc:mod $e 19 1
        mc:modset $e 26 [unixtime]        
        if {[mc:modget $e 16] == "m" || [mc:modget $e 16] == "p"} {
           set t1 [expr round(([mc:modget $e 3] + $te($e)) / 120)]
           set t2 [expr round([mc:modget $e 3] / 120)]
           set newbon [expr $t1 - $t2]
           if {$newbon >= 1} {
              mc:mod $e 18 $newbon
              mc:msg $nnick($e) [format $cth(33) $newbon [mc:modget $e 18]]
           }
        }
        if {[mc:modget $e 16] == "w" || [mc:modget $e 16] == "l"} {
           set t1 [expr round(([mc:modget $e 3] + $te($e)) / 120)]
           set t2 [expr round([mc:modget $e 3] / 120)]
           set newbon [expr $t1 - $t2]
           if {$newbon >= 1} {
              mc:mod $e 28 $newbon
              mc:msg $nnick($e) [format $cth(33w) $newbon [mc:modget $e 28]]
           }
        }
        if {[array exists mcc]} {
           set cid [mc:comid $mcc($mcr($e))]
           if {[info exists mco($cid)]} {
               mc:mcomset $cid 15 [unixtime]
           }
        }
        mc:mod $e 3 $te($e)
        set iii 2
        set iad 1000.0
        set irs 1000.0
        set freehark 10
        while {$iad <= [mc:modget $e 3]} {
            if {[mc:modget $e 17] < $iii} {
                mc:mod $e 17 1
                mc:mod $e 10 1
                mc:mod $e 9 [expr $freehark + [mc:modget $e 30]]
                mc:msg $nnick($e) [format $ct(52) [mc:modget $e 17]]
            }
            set iad [expr $iad + $irs]
            set irs [expr $irs * 2]
            incr iii
        }
     }
  }
  if {[array exists mce]} { unset mce }
  if {[array exists uhosts]} { unset uhosts }
  if {[array exist oldtodo]} {unset oldtodo}
  if {[info exist ghost]} { unset ghost }
  if {[info exist killed]} { unset killed }
  if {[array exists uhosts]} { unset uhosts }
  if {[array exists victim]} { unset victim }
  if {[array exists victims]} { unset victims }
  if {[info exists poifail]} { unset poifail }
  set noreg 1
  if {[array exists mcr]} { unset mcr }
  if {[array exists mcc]} { unset mcc }
  if {[array exists liv]} { unset liv }
  mc:say [format $cth(82cb) $stopnick]
  mc:save
  utimer 30 { mc:startreg }
  utimer 30 { set mc(phase) 0 }
}

#   text  id
proc mc:offlinemessage {id text} {
    global mc

    set fid [open $mc(offline) a+]
    puts $fid "$id|[ms:fl "[ctime [unixtime]] - $text"]"
    close $fid
}

#   text     logfile
proc mc:putfilelog {logfile userhost text} {
    global mc
    
    if {![info exists logfile] || $logfile == ""} {
       set logfile $mc(deflog)    
    }
    set fid [open $logfile a+]
    puts $fid "[ctime [unixtime]] - ($userhost) - $text"
    close $fid
}

proc mc:convert {n uh h t} {
    global thi cth mc liv
    
    set id [tolower [ms:fl $n]]
    if {![mc:check $id -]} {return}
    if {[info exists liv($id)]} { return }

    if {[mc:modget $id 16] == "w" || [mc:modget $id 16] == "l"} {
        set bon [mc:modget $id 28]
        if {[mc:modget $id 17] < 5 && [mc:modget $id 30] == 0} {
           mc:msg $n $cth(75ab)
           return
        }
        if {[llength $t] < 2} {
           set tout ""
           foreach e [array names thi] {
              if {($e != "") && ([mc:wget $e type] == "p" || [mc:wget $e type] == "c") && ([mc:checkin [mc:modget $id 16] [mc:wget $e cnvr]]) && ([mc:wget $e cnv] > 0)} {
                 if {[mc:wget $e cnv] <= $bon} {
                    set prf "10"
                 } else {
                    set prf "14"
                 }
                 set tout [lappend tout "$prf$e.[mc:wget $e name]\([mc:wget $e cnv]b\)"]
                 if {[string length $tout] > 380} {
                    set tout [join $tout ", "]
                    mc:msg $n [format $cth(81j) $tout]
                    set tout ""
                 }
              }
           }       
           if {$tout != ""} {
              set tout [join $tout ", "]
              mc:msg $n [format $cth(81j) $tout]
           }
           return
        }
        set par [tolower [lindex $t 1]]
        if {![info exists thi($par)]} {
           mc:msg $n $cth(81c)
           return
        }
        if {[mc:wget $par cnv] > $bon} {
           mc:msg $n $cth(81d)
           return
        }
        if {![mc:checkin [mc:modget $id 16] [mc:wget $par cnvr]]} {
           mc:msg $n $cth(81e)
           return
        }
        mc:modset $id 28 [expr $bon - [mc:wget $par cnv]]
        foreach pp [mc:modget $id 13] {
           set tarr([lindex $pp 1]) 1
        }
        set nn 0
        for {set i 0} {$i <= [array size tarr]} {incr i} {
           if {![info exist tarr($i)]} {
              set nn $i
              break
           }
        }
        set bon [mc:wget $par cnv]
        if {$bon == 1} {
           set bonx $cth(81g)
        } elseif {$bon < 5} {
           set bonx $cth(81h)
        } else {
           set bonx $cth(81i)
        }
        set oo [mc:modget $id 13]
        mc:modset $id 13 [lappend oo "$par $nn 0 {{$id [clock seconds]} 0}"]
        mc:msg $n [format $cth(81fw) [mc:wget $par name] $bon $bonx]
    }
    if {[mc:modget $id 16] == "m" || [mc:modget $id 16] == "p"} {
        set bon [mc:modget $id 18]
        if {[mc:modget $id 17] < 5 && [mc:modget $id 30] == 0} {
           mc:msg $n $cth(75a)
           return
        }
        if {[llength $t] < 2} {           
           set tout ""
           foreach e [array names thi] {
              if {($e != "") && ([mc:wget $e type] == "p") && ([mc:checkin [mc:modget $id 16] [mc:wget $e cnvr]]) && ([mc:wget $e cnv] > 0)} {
                 if {[mc:wget $e cnv] <= $bon} {
                    set prf "10"
                 } else {
                    set prf "14"
                 }
                 set tout [lappend tout "$prf$e.[mc:wget $e name]\([mc:wget $e cnv]b\)"]
                 if {[string length $tout] > 380} {
                    set tout [join $tout ", "]
                    mc:msg $n [format $cth(81j) $tout]
                    set tout ""
                 }
              }
           }       
           if {$tout!=""} {
              set tout [join $tout ", "]
              mc:msg $n [format $cth(81j) $tout]
           }
           return
        }
        set par [tolower [lindex $t 1]]
        if {![info exists thi($par)]} {
           mc:msg $n $cth(81c)
           return
        }
        if {[mc:wget $par cnv] > $bon} {
           mc:msg $n $cth(81d)
           return
        }
        if {![mc:checkin [mc:modget $id 16] [mc:wget $par cnvr]]} {
           mc:msg $n $cth(81e)
           return
        }
        mc:modset $id 18 [expr $bon - [mc:wget $par cnv]]
        foreach pp [mc:modget $id 13] {
           set tarr([lindex $pp 1]) 1
        }
        set nn 0
        for {set i 0} {$i <= [array size tarr]} {incr i} {
           if {![info exist tarr($i)]} {
              set nn $i
              break
           }
        }
        set bon [mc:wget $par cnv]
        if {$bon == 1} {
           set bonx $cth(81g)
        } elseif {$bon < 5} {
           set bonx $cth(81h)
        } else {
           set bonx $cth(81i)
        }
        set oo [mc:modget $id 13]
        mc:modset $id 13 [lappend oo "$par $nn 0 {{$id [clock seconds]} 0}"]
        mc:msg $n [format $cth(81f) [mc:wget $par name] $bon $bonx]
    }
}

#     ()
proc mc:clook {n uh h c t} {
    global mcs mc ct cth rnam lastclook mco
    global botmoney

    set id [tolower [ms:fl $n]]
    if {![mc:check $id -]} {return}    
    if {[info exist lastclook] && ($lastclook > [clock seconds])} {return}
    if {[queuesize] > 10} {return}
    if {[llength $t] < 2} {return}

    set cid [lrange [tolower [ms:fl $t]] 1 end]
    set cid [mc:comid $cid]

    if {![info exist mco($cid)]} {
       mc:notice $n " <[join [lrange $t 1 end]]>  ."
       return
    }

    ###  
    set cpl 0
    foreach pl [mc:mcomget $cid 1] {
      if {[lindex $pl 1] > 0} { incr cpl }
    }

    ###   
    if {[mc:mcomget $cid 15] > 0} {
      set pt [clock format [mc:modget $id 26] -format "%d.%m %H:%M"]
    } else {
      set pt ""
    }

    ###   
    if {[mc:mcomget $cid 7]} {
       set out [format $ct(60b) [mc:mcomget $cid 0] [mc:mcomget $cid 2] [mc:mcomget $cid 3] [mc:mcomget $cid 14]]
    } else {
       set out [format $ct(60a) [mc:mcomget $cid 0] [mc:mcomget $cid 2] [mc:mcomget $cid 3] [mc:mcomget $cid 14]]
    }
    if {[mc:mcomget $cid 4]} {
       set out "$out$ct(60d)"
    } else {
       set out "$out$ct(60c)"
    }
    set out "$out[format $ct(60e) $cpl]"
    if {[isnumber [mc:mcomget $cid 6]] && [mc:mcomget $cid 6] > 0} { 
       set out "$out[format $ct(60f) [mc:mcomget $cid 6]]"
    }
    set out "$out[format $ct(60g) $pt]"
    if {[mc:mcomget $cid 7]} {
       if {[string length [mc:mcomget $cid 8]] > 0 && [mc:mcomget $cid 8] != 0} {
          set out "$out[format $ct(60h) [mc:mcomget $cid 8]]"
       }
    }
    if {[mc:modget $id 11] < 1} {
       mc:msg $n $cth(79d)
       return
    }
    set pay4look "1"
    mc:mod $id 11 "-$pay4look"
    bots:say $n [join $t]
    mc:msg $id "   <[lrange $t 1 end]>    1 gold."    
    mc:say $out
    set lastclook [expr [clock seconds] + 30]
    set botmoney [expr $botmoney + $pay4look]

}

#     ()
proc mc:mclook {n uh h t} {
    global mcs mc ct cth rnam mco
    set id [tolower [ms:fl $n]]
    
    if {![mc:check $id -]} {return}
    if {[queuesize]>10} {return}
    if {[llength $t]<2} {return}

    set cid [lrange [tolower [ms:fl $t]] 1 end]
    set cid [mc:comid $cid]

    if {![info exist mco($cid)]} {
       mc:msg $n " <[lrange $t 1 end]>  ."
       return
    }
    if {![mc:mcomget $cid 10] && [mc:comga $cid $id] < 1} { return }

    ###  
    set cpl 0
    foreach pl [mc:mcomget $cid 1] {
      if {[lindex $pl 1] > 0} { incr cpl }
    }
    ###   
    if {[mc:mcomget $cid 15] > 0} {
       set pt [clock format [mc:modget $id 26] -format "%d.%m %H:%M"]
    } else {
       set pt ""
    }
    ###   
    if {[mc:mcomget $cid 7]} {
       set out [format $ct(60b) [mc:mcomget $cid 0] [mc:mcomget $cid 2] [mc:mcomget $cid 3] [mc:mcomget $cid 14]]
    } else {
       set out [format $ct(60a) [mc:mcomget $cid 0] [mc:mcomget $cid 2] [mc:mcomget $cid 3] [mc:mcomget $cid 14]]
    }
    if {[mc:mcomget $cid 4]} {
       set out "$out$ct(60d)"
    } else {
       set out "$out$ct(60c)"
    }
    set out "$out[format $ct(60e) $cpl]"
    if {[isnumber [mc:mcomget $cid 6]] && [mc:mcomget $cid 6] > 0} { 
       set out "$out[format $ct(60f) [mc:mcomget $cid 6]]"
    }
    set out "$out[format $ct(60g) $pt]"
    if {[mc:mcomget $cid 7]} {
       if {[string length [mc:mcomget $cid 8]] > 0 && [mc:mcomget $cid 8]!=0} {
          set out "$out[format $ct(60h) [mc:mcomget $cid 8]]"
       }
    }
    if {[mc:mcomget $cid 7]} {
       if {[mc:mcomget $cid 12]} {       
          set out "$out$ct(60j)"
          set out "$out[format $ct(60l) [mc:mcomget $cid 13]]"
       } else {
          set out "$out$ct(60k)"
       }
    }

    mc:msg $n $out
}

#     
proc mc:kickban {n uh h t} {
    global mc

    if {![mc:ismaster $h]} { 
       mc:noticefriends "$n tryed to ban [lindex $t 1]" 
       return
    }
    if {[llength $t] < 4} {
       mc:msg $n "bans and kicks <nick>"
       mc:msg $n "!ban <nick> <comment> <lifetime>"
       return
    }
    #   
    newchanban $mc(chan) [lindex $t 1]!*@* $n [lindex $t 2] [lindex $t 3]
    #   
    newchanban $mc(chan) [getchanhost [lindex $t 1]] $n [lindex $t 2] [lindex $t 3]
    # 
    putkick $mc(chan) [lindex $t 1] [lindex $t 2]
    mc:noticefriends "$n baned [lindex $t 1] for [lindex $t 3] minutes..."
}

# +f  userlist
proc mc:isfriend {hand} {
    global mc

    if {("[info procs auth:check]"!="")&&(![auth:check $hand])} { return 0 }
    if {[regexp "f" "[chattr $hand]"] || [regexp "f" "[chattr $hand $mc(chan)]"]} { return 1 }
    return 0
}

#    +f
proc mc:noticefriends {t} {
    global mc
    foreach nn [chanlist $mc(chan) f] {
       putserv "NOTICE $nn :$t"
    }
}

#   
proc mc:mpunish {n uh h t} {
    global mcs mc ct cth

    set id [tolower [ms:fl $n]]

    if {![mc:isfriend $h]} { return }    
    if {[llength $t] < 4} {
      mc:msg $n "syn: !punish   "
      mc:msg $n ": 300 -  , 500-600 -      "
      mc:msg $n "   1000."
      return 
    }
    set who [tolower [ms:fl [lindex $t 1]]]
    if {![info exists mcs($who)]} {
      mc:msg $n "  !"
      return 
    }
    if {![isnumber [lindex $t 2]] || [lindex $t 2] <= 0 || ([lindex $t 2] > 4000 && ![mc:ismaster $h])} {
      mc:msg $n "    !"
      return 
    }
    set exp [lindex $t 2]
    if {[llength $t] >= 4} {
     set reason [lrange $t 3 end]
    } else {
     set reason [lindex $t 3]
    }    
    mc:noticefriends "[lindex $t 1]   $exp by $n  [lrange $t 3 end]"
    mc:msg [lindex $t 1] [format $ct(666) $exp $reason]
    mc:msg $n "[lindex $t 1]   $exp"
    mc:mod $who 3 "-$exp"
}

# 
proc mc:mfpunish {n uh h t} {
    global mcs mc ct cth

    set id [tolower [ms:fl $n]]

    if {![mc:isfriend $h]} { return }
    if {[llength $t] < 4} {
      mc:msg $n "syn: !shtr   "
      mc:msg $n ": 300 -  , 500-600 -      "
      mc:msg $n "   1000."
      return 
    }
    set who [tolower [ms:fl [lindex $t 1]]]
    if {![info exists mcs($who)]} {
      mc:msg $n "  !"
      return 
    }
    if {![isnumber [lindex $t 2]] || [lindex $t 2] <= 0} {
      mc:msg $n "    !"
      return 
    }
    set exp [lindex $t 2]
    if {[llength $t] >= 4} {
     set reason [lrange $t 3 end]
    } else {
     set reason [lindex $t 3]
    }
    mc:noticefriends "[lindex $t 1]   $exp by $n  [lrange $t 3 end]"
    mc:msg $n "[lindex $t 1]   $exp"
    mc:msg [lindex $t 1] [format $ct(666) $exp $reason]
}

#  
proc mc:ctop5 {n uh h c t} {
    global mcs mc rnam lasttop5 mco ct
    global botmoney

    set id [tolower [ms:fl $n]]
    if {![mc:check $id -]} {return}    
    if {[info exist lasttop5] && ($lasttop5 > [clock seconds])} {return}
    if {[queuesize]>10} {return}
    if {[llength $t] > 1} { set [tolower par [lindex $t 1]] }
    if {[info exists par]} {
       if {$par == "wins"} { set sb 3 }
       if {$par == "games"} { set sb 2 }
       if {$par == "gold" || $par == "money"} { set sb 14 }
    } else {
       set sb 3
    }

    set com1 ""
    set num1 0
    foreach pp [array names mco] {
     if {[info exists mco($pp)] && [lindex $mco($pp) $sb] > 0} {
        set curn [lindex $mco($pp) 3]
        if {$curn > $num1} {
           set num1 $curn
           set com1 $pp
        }
     }
    }

    set com2 ""
    set num2 0
    foreach pp [array names mco] {
     if {[info exists mco($pp)] && [lindex $mco($pp) $sb] > 0} {
        set curn [lindex $mco($pp) 3]
        if {$curn > $num2 && $curn < $num1} {
           set num2 $curn
           set com2 $pp
        }
     }
    }

    set com3 ""
    set num3 0
    foreach pp [array names mco] {
     if {[info exists mco($pp)] && [lindex $mco($pp) $sb] > 0} {
        set curn [lindex $mco($pp) 3]
        if {$curn > $num3 && $curn < $num2} {
           set num3 $curn
           set com3 $pp
        }
     }
    }

    set com4 ""
    set num4 0
    foreach pp [array names mco] {
     if {[info exists mco($pp)] && [lindex $mco($pp) $sb] > 0} {
        set curn [lindex $mco($pp) 3]
        if {$curn > $num4 && $curn < $num3} {
           set num4 $curn
           set com4 $pp
        }
     }
    }

    set com5 ""
    set num5 0
    foreach pp [array names mco] {
     if {[info exists mco($pp)] && [lindex $mco($pp) $sb] > 0} {
        set curn [lindex $mco($pp) 3]
        if {$curn > $num5 && $curn < $num4} {
           set num5 $curn
           set com5 $pp
        }
     }
    }

    if {[info exists mco($com1)] && [info exists mco($com2)] && [info exists mco($com3)] && [info exists mco($com4)] && [info exists mco($com5)] && [mc:modget $id 11] >= 1} {
       set pay4look 1
       mc:mod $id 11 -$pay4look
       bots:say $n [join $t]
       mc:msg $id "  ctop5    1 gold."
       mc:say [format $ct(54) [ms:dfl [mc:mcomget $com1 0]] [lindex $mco($com1) 2] [lindex $mco($com1) 3] [ms:dfl [mc:mcomget $com2 0]] [lindex $mco($com2) 2] [lindex $mco($com2) 3] [ms:dfl [mc:mcomget $com3 0]] [lindex $mco($com3) 2] [lindex $mco($com3) 3] [ms:dfl [mc:mcomget $com4 0]] [lindex $mco($com4) 2] [lindex $mco($com4) 3] [ms:dfl [mc:mcomget $com5 0]] [lindex $mco($com5) 2] [lindex $mco($com5) 3] ]
       set lasttop5 [expr [clock seconds] + 300]
       set botmoney [expr $botmoney + $pay4look]
    }
}

#  
proc mc:ptop5 {n uh h c t} {
    global mcs mc rnam lastptop5 ct
    global botmoney

    set id [tolower [ms:fl $n]]
    if {![mc:check $id -]} {return}    
    if {[info exist lastptop5] && ($lastptop5 > [clock seconds])} {return}
    if {[queuesize]>10} {return}
    if {[llength $t] > 1} { set par [tolower [lindex $t 1]] }
	
    set sb 20
    if {[info exists par]} {
       if {$par == "wins"} { set sb 20 }
       if {$par == "craft" || $par == "crafters"} { set sb 36 }
       if {$par == "games"} { set sb 19 }
       if {$par == "gold" || $par == "money"} { set sb 11 }
       if {$par == "exp"} { set sb 3 }
       if {$par == "kills"} { set sb 32 }
       if {$par == "deaths"} { set sb 39 }
       if {$par == "warriors" || $par == "w"} {
	       set sr "w"
       }
       if {$par == "archers" || $par == "l"} {
	       set sr "l"
       }
       if {$par == "wizards" || $par == "m"} {
	       set sr "m"
       }       
       if {$par == "priests" || $par == "p"} {
	       set sr "p"
       }       
    }

    set plr1 ""
    set num1 0
    foreach pp [array names mcs] {
     if {[info exists mcs($pp)] && [mc:modget $pp $sb] > 0 && (![info exists sr] || ([info exists sr] && [mc:modget $pp 16] == $sr))} {
        set curn [mc:modget $pp $sb]
        if {$curn > $num1} {
           set num1 $curn
           set plr1 $pp
        }
     }
    }

    set plr2 ""
    set num2 0
    foreach pp [array names mcs] {
     if {[info exists mcs($pp)] && [mc:modget $pp $sb] > 0 && (![info exists sr] || ([info exists sr] && [mc:modget $pp 16] == $sr))} {
        set curn [mc:modget $pp $sb]
        if {$curn > $num2 && $curn < $num1} {
           set num2 $curn
           set plr2 $pp
        }
     }
    }

    set plr3 ""
    set num3 0
    foreach pp [array names mcs] {
     if {[info exists mcs($pp)] && [mc:modget $pp $sb] > 0 && (![info exists sr] || ([info exists sr] && [mc:modget $pp 16] == $sr))} {
        set curn [mc:modget $pp $sb]
        if {$curn > $num3 && $curn < $num2} {
           set num3 $curn
           set plr3 $pp
        }
     }
    }

    set plr4 ""
    set num4 0
    foreach pp [array names mcs] {
     if {[info exists mcs($pp)] && [mc:modget $pp $sb] > 0 && (![info exists sr] || ([info exists sr] && [mc:modget $pp 16] == $sr))} {
        set curn [mc:modget $pp $sb]
        if {$curn > $num4 && $curn < $num3} {
           set num4 $curn
           set plr4 $pp
        }
     }
    }

    set plr5 ""
    set num5 0
    foreach pp [array names mcs] {
     if {[info exists mcs($pp)] && [mc:modget $pp $sb] > 0 && (![info exists sr] || ([info exists sr] && [mc:modget $pp 16] == $sr))} {
        set curn [mc:modget $pp $sb]
        if {$curn > $num5 && $curn < $num4} {
           set num5 $curn
           set plr5 $pp
        }
     }
    }

    if {[info exists mcs($plr1)] && [info exists mcs($plr2)] && [info exists mcs($plr3)] && [info exists mcs($plr4)] && [info exists mcs($plr5)] && [mc:modget $id 11] >= 1} {
       set pay4look 1
       mc:mod $id 11 -$pay4look
       mc:msg $id "  ptop5    1 gold."
       bots:say $n [join $t]
       mc:say [format $ct(54a) [ms:dfl [mc:modget $plr1 0]] [mc:modget $plr1 19] [mc:modget $plr1 20] [ms:dfl [mc:modget $plr2 0]] [mc:modget $plr2 19] [mc:modget $plr2 20] [ms:dfl [mc:modget $plr3 0]] [mc:modget $plr3 19] [mc:modget $plr3 20] [ms:dfl [mc:modget $plr4 0]] [mc:modget $plr4 19] [mc:modget $plr4 20] [ms:dfl [mc:modget $plr5 0]] [mc:modget $plr5 19] [mc:modget $plr5 20] ]
       set lastptop5 [expr [clock seconds] + 45]
       set botmoney [expr $botmoney + $pay4look]
    }
}

#  
proc mc:transfer {n uh h t} {
    global mcs mc ct cth nick auction
    
    set id [tolower [ms:fl $n]]
    if {![mc:check $id -]} {return}
    if {[mc:modget $id 17] < 2 && [mc:modget $id 30] == 0} {
       mc:msg $n $cth(75a)
       return
    }
    if {[llength $t] < 3} {
       mc:msg $n $cth(75b)
       return
    }
    set toid [tolower [lindex [ms:fl $t] 1]]
    if {![info exists mcs($toid)]} {
       mc:msg $n [format $cth(75c) [lindex $t 1]]
       return
    }
    if {![isnumber [lindex $t 2]]} {
       mc:msg $n $cth(75b)
       return
    }
    if {[lindex $t 2] > [mc:modget $id 11]} {
       mc:msg $n $cth(75d)
       return
    }
    if {[array exists auction] && $auction(currentnck) == $id && [expr [mc:modget $id 11] - [lindex $t 2]] < $auction(currentbid)} {
	  mc:msg $n $cth(75h)
	  return
    }
    putcmdlog "4TRANSFER: $n $t"
    mc:putfilelog "logs/$nick.moneytransfers.[clock format [unixtime] -format "%d.%m.%Y"].log" $uh "TRANSFER: $n $t"
    mc:notice $mc(notchan) "transfer: $n $t"
    mc:mod $id 11 -[lindex $t 2]
    mc:mod $toid 11 [lindex $t 2]
    mc:msg $n [format $cth(75e) [lindex $t 1] [lindex $t 2]]
    if {[lrange $t 3 end] != ""} {
       set out [format $cth(75g) $n [lindex $t 2] [lrange $t 3 end]]
    } else {
       set out [format $cth(75f) $n [lindex $t 2]]
    }
    if {[lindex $t 2] > 1000} {
       mc:noticefriends "4TRANSFER: $n $t" 
    }
    if {![mc:check $toid -]} {
       mc:offlinemessage $toid $out
    } else {
       mc:msg [lindex $t 1] $out
    }
}

#   
proc mc:ttransfer {n uh h t} {
    global mcs mc cth liv nick auction

    set id [tolower [ms:fl $n]]
    if {![mc:check $id -]} { return }

    if {[llength $t] < 3} {
       mc:msg $n $cth(80a_)
       return
    }
    set toid [tolower [ms:fl [lindex $t 1]]]
    if {![info exists mcs($toid)]} {
       mc:msg $n [format $cth(75c) [lindex $t 1]]
       return
    }
    ###     
    set nn [lindex $t 2]
    if {![isnumber $nn] || $nn < 1} {
       mc:msg $n $cth(80b)
       return
    }
    ###    
    set pr [mc:modget $id 13]
    set isin 0
    set prr ""
    set th ""
    foreach pp $pr {
        if {[lindex $pp 1] == $nn} {
           set th $pp
           set isin 1
        } else {
           set prr [lappend prr $pp]
        }
    }
    if {$isin} {
       if {[lindex $th 2]} {
          mc:msg $n $cth(80h)
          return
       }
       set mx [lindex $th 0]
       set cl [lindex [lindex $th 3] 0]
       if {([lindex $cl 0] != $id && [lindex $cl 0] != $toid) || [lindex $cl 0] == "- -"} {
       ###  (ops only)
	       if {![isop $n $mc(chan)]} {
		       mc:msg $n $cth(80m)
		       return
	       }
       }
       if {[expr [mc:realweight $toid] + [mc:wget $mx weight]] > [mc:maxweight $toid]} {
          mc:msg $n [format $cth(80k) [lindex $t 1]]
          return
       }
       if {![mc:checkin [mc:modget $toid 16] [mc:wget $mx race]]} {
          mc:msg $n [format $cth(80f) [lindex $t 1]]
          return
       }
       if {[array exists auction] && $auction(starter) == $id && $auction(thnumber) == $nn} {
          mc:msg $n $cth(80o)
          return
       }
       ###    
       mc:modset $id 13 $prr
       ###        
       foreach pp [mc:modget $toid 13] {
          set tarr([lindex $pp 1]) 1
       }
       set nn 0
       for {set i 0} {$i <= [array size tarr]} {incr i} {
          if {![info exist tarr($i)]} {
             set nn $i
             break
          }
       }
       ###  , 
       set oo [mc:modget $toid 13]
       putcmdlog "4TTRANSFER: $n [ms:dfl $toid] [mc:wget $mx name]"
       mc:putfilelog "logs/$nick.thingstransfers.[clock format [unixtime] -format "%d.%m.%Y"].log" $uh "4TTRANSFER: $n [ms:dfl $toid] [mc:wget $mx name]"
       mc:notice $mc(notchan) "ttransfer: $n [ms:dfl $toid] [mc:wget $mx name]"
       mc:modset $toid 13 [lappend oo "$mx $nn 0 {[lindex $th 3]}"]
       mc:msg $n [format $cth(80d) [lindex $t 1] [mc:wget $mx name]]
       if {[mc:check $toid -]} {
          mc:msg [ms:dfl $toid] [format $cth(80e) $n [mc:wget $mx name]]
       } else {
          mc:offlinemessage $toid [format $cth(80e) $n [mc:wget $mx name]]
       }
    } else {
       mc:msg $n $cth(80c)
    }	
}

#  
proc mc:ptransfer {n uh h t} {
    global mcs mc cth liv nick
    
    set id [tolower [ms:fl $n]]

    if {![mc:check $id -]} { return }
    if {$mc(phase) != 0 && ![info exists liv($id)]} {
       mc:msg $n $cth(75aa)
       return
    }
    if {[mc:modget $id 17] < 2 && [mc:modget $id 30] == 0} {
       mc:msg $n $cth(75a)
       return
    }
    if {[llength $t] < 3} {
       mc:msg $n $cth(80a)
       return
    }
    set toid [tolower [ms:fl [lindex $t 1]]]
    if {![info exists mcs($toid)]} {
       mc:msg $n [format $cth(75c) [lindex $t 1]]
       return
    }
    ###     
    set nn [lindex $t 2]
    if {![isnumber $nn]} {
       mc:msg $n $cth(80b)
       return
    }
    ###    
    set pr [mc:modget $id 13]
    set isin 0
    set prr ""
    set th ""
    foreach pp $pr {
        if {[lindex $pp 1] == $nn} {
           set th $pp
           set isin 1
        } else {
           set prr [lappend prr $pp]
        }
    }
    ###    
    set mix [lindex $th 0]
    if {[mc:wget $mix type] != "p"} {
         mc:msg $n $cth(80b)
         return
    }
    if {$isin} {
       if {[lindex $th 2]} {
          mc:msg $n $cth(80h)
          return
       }
       set mx [lindex $th 0]
       if {$mc(phase) != 0 && [mc:wget $mx type] != "p"} {
          mc:msg $n $cth(80g)
          return
       }
       if {[expr [mc:realweight $toid] + [mc:wget $mx weight]] > [mc:maxweight $toid]} {
          mc:msg $n [format $cth(80k) [lindex $t 1]]
          return
       }
       if {![mc:checkin [mc:modget $toid 16] [mc:wget $mx race]]} {
          mc:msg $n [format $cth(80f) [lindex $t 1]]
          return
       }
       ###    
       mc:modset $id 13 $prr
       ###        
       foreach pp [mc:modget $toid 13] {
          set tarr([lindex $pp 1]) 1
       }
       set nn 0
       for {set i 0} {$i <= [array size tarr]} {incr i} {
          if {![info exist tarr($i)]} {
             set nn $i
             break
          }
       }
       ###  , 
       set oo [mc:modget $toid 13]
       putcmdlog "4PTRANSFER: $n [ms:dfl $toid] [mc:wget $mx name]"
       mc:putfilelog "logs/$nick.poitiontransfers.[clock format [unixtime] -format "%d.%m.%Y"].log" $uh "4PTRANSFER: $n [ms:dfl $toid] [mc:wget $mx name]"
       mc:notice $mc(notchan) "ptransfer: $n [ms:dfl $toid] [mc:wget $mx name]"
       mc:modset $toid 13 [lappend oo "$mx $nn 0 {[lindex $th 3]}"]
       mc:msg $n [format $cth(80d) [lindex $t 1] [mc:wget $mx name]]
       if {[mc:check $toid -]} {
          mc:msg [ms:dfl $toid] [format $cth(80e) $n [mc:wget $mx name]]
       } else {
          mc:offlinemessage $toid [format $cth(80e) $n [mc:wget $mx name]]
       }
    } else {
       mc:msg $n $cth(80c)
    }
} 

#  
proc mc:backup {} {
    global mc mcs mco
    file copy -force $mc(file) $mc(bfile).[clock format [unixtime] -format "%d.%m.%Y.%H"].backup
    file copy -force $mc(coms) $mc(bcoms).[clock format [unixtime] -format "%d.%m.%Y.%H"].backup
    putcmdlog "Backing up Arena score file for [clock format [unixtime] -format "%d.%m.%Y.%H"]..."
}

proc mc:mbackup {n uh h t} {
    global mc mcs mco ct cth
    mc:msg $n [format $cth(76c) [clock format [unixtime] -format "%d %m %Y %H:%M"]]
    mc:backup
}

#  
proc mc:mrepair {n uh h t} {
    global mc mcs mco ct cth
    if {[llength $t] < 2} {
       mc:msg $n $cth(76a)
       return
    }
    if {(![file exists $mc(bfile).[lindex $t 1].backup]) || (![file exists $mc(bcoms).[lindex $t 1].backup])} {
       mc:msg $n [format $cth(76b) [lindex $t 1]]
       return
    }
    mc:msg $n [format $cth(76c) [lindex $t 1]]
    mc:backup
    mc:msg $n [format $cth(76d) [lindex $t 1]]
    file copy -force $mc(bfile).[lindex $t 1].backup $mc(file)
    file copy -force $mc(bcoms).[lindex $t 1].backup $mc(coms)
    mc:msg $n [format $cth(76e) [lindex $t 1]]
    mc:read
}
