
#     2 .  - 2
#     3 .  - 2:10
#     4 .  - 2:20
#     5 .  - 2:30
#     6 .  - 2:36
#     7 .  - 2:42
#     8 .  - 2:48
#     9 .  - 2:54
#     10 . - 3:00
#     15 . - 3:30
#     20 . - 4:00

proc mc:killghost {} {
    global ghost mc prc todo liv roundstart livnumber nnick ct clears killed

    utimer 10 { mc:killghost }
    if {$mc(phase) != 1} { return }

    set i 0
    set rl 0
    foreach nn [array names liv] {
       incr i
       if {$i < 3} {
          set rl [expr $rl + 60]
       } elseif {$i < 5} {
          set rl [expr $rl + 10]
       } else {
          set rl [expr $rl + 6]
       }
    }
    set roundlenght $rl

    if {[expr [expr $roundstart + $roundlenght] - [clock seconds]] <= 20 && [expr [expr $roundstart + $roundlenght] - [clock seconds]] >= 15} {
        mc:say "   !"
    }

    if {[expr $roundstart + $roundlenght] > [clock seconds]} { return }

    foreach id [array names liv] {
        if {$prc($id) == 100} {
            set todo($id) [lappend todo($id) "r"]
            set prc($id) 0
            if {([array exist ghost] && ![info exist ghost($id)]) || ![array exist ghost]} {
                mc:msg [ms:dfl $nnick($id)] $ct(53)
                set killed($id) 1
            }
        } elseif {$prc($id) > 0} {
            set prc($id) 0
            if {[array exist ghost] && [info exist ghost($id)]} {
                set todo($id) [lappend todo($id) "r"]
            }
        }
        if {[array exist ghost] && [info exist ghost($id)]} {
            unset ghost($id)
        }
    }
    mc:checkend
}

proc mc:r_leave {n tt} {
  global mc mcs mcr liv ghost ct killed
  set id [tolower [ms:fl $n]]

  if {([array exist killed])&&([info exists killed($id)])} { return }
  if {![info exists mcs($id)]} { return }
  if {([info exist mc(ident)]) && ([lsearch -exact $mc(ident) $id] != -1)} {
    set nn [lsearch -exact $mc(ident) $id]
    set mc(ident) [lreplace $mc(ident) $nn $nn]
  }
  if {$mc(phase) == 0} {
    if {[info exist mcs($id)]} {
       mc:punreg $n boo boo $mc(chan) boo
    }
  } else {
    if {[info exist liv($id)]} {
      mc:say [format $ct(0b) [ms:dfl [mc:modget $id 0]]]
      set ghost($id) [clock seconds]
    }
  }
}

proc mc:r_join {n} {
  global mc mcs ct ghost prc liv ct
  global mcc mcr
  
  set id [tolower [ms:fl $n]]

  if {![info exists mcs($id)]} { return }
#  if {($n == "_Nest_") || ($n == "Goggist") || ($n == "Topoly")} {
#      timer [rand 120] {mc:br}
#  }
  if {[mc:modget $id 1] != "-nopass-"} {
    mc:notice $n $ct(0)
  } elseif {[info exists mcs($id)]} {
    # 
    if {[file exists $mc(offline)]} {
        set fid1 [open $mc(offline) r]
        set i 0
        set mesgp ""
        while {![eof $fid1]} {
            gets $fid1 l
            if {[lindex [split $l |] 0] == $id && $i < 3} {
              set i [expr $i + 1]
              mc:notice $n "[ms:dfl [lindex [lrange [split $l |] 1 end] 0]]"
            } else {
              set mesgp [lappend mesgp $l]
            }
        }
        close $fid1
        set fid2 [open $mc(offline) w]
        foreach mesgs $mesgp {
           if {$mesgs != ""} { puts $fid2 $mesgs }
        }
        close $fid2
    }
    # end
  }
  if {[array exist ghost] && [info exist ghost($id)] && [info exists liv($id)]} {
    unset ghost($id)
    if {$mc(twobots)} {
       mc:putslave voice $n
       # mc:putslave rawcmd_fast "MODE $mc(chan) +v $n"
    } else {
       pushmode $mc(chan) +v $n
    }
    if {$mc(phase) == 1} {
      if {$prc($id) == 0} {
        mc:msg $n $ct(0d)
      } else {
        mc:msg $n [format $ct(0c) $prc($id)]
        mc:sendsplit $n 400 [mc:list]
      }
    }
  }
}

proc mc:spart {n uh h c {m ""}} {
  mc:r_leave $n 1
}

proc mc:ssign {n uh h c r} {
  mc:r_leave $n 1
}

proc mc:skick {n uh h c t r} {
  mc:r_leave $t 1
}

proc mc:snick {n uh h c nn} {
  mc:r_leave $n 1
  mc:r_join $nn
}

proc mc:ssplt {n uh h c} {
  mc:r_leave $n 1
}

proc mc:srejn {n uh h c} {
  mc:r_join $n
}

proc mc:sjoin {n uh h c} {
  global noreg ct
  
  if {$noreg == 0} {
      mc:notice $n $ct(rega)
  }
  mc:r_join $n
}
