
set permskill(gsm)   "{} {         ( !tmake, !tex, !raw  !shop y).        }"
set _permskill(gsm1) "50 55"
set _permskill(gsm2) "100 60"
set _permskill(gsm3) "200 65"
set _permskill(gsm4) "300 70"
set _permskill(gsm5) "400 75"
set _permskill(gsm6) "500 80"

set permskill(gjw)   "{} {           ( !tmake, !tex, !raw  !shop y).        }"
set _permskill(gjw1) "50 55"
set _permskill(gjw2) "100 60"
set _permskill(gjw3) "200 65"
set _permskill(gjw4) "300 70"
set _permskill(gjw5) "400 75"
set _permskill(gjw6) "500 80"

set permskill(ws)   "{   } {   ,        }"
set _permskill(ws1) "50 55"
set _permskill(ws2) "100 60"
set _permskill(ws3) "200 65"
set _permskill(ws4) "300 70"
set _permskill(ws5) "400 75"
set _permskill(ws6) "500 80"

set permskill(wc)   "{   } {   ,      }"
set _permskill(wc1) "50 3"
set _permskill(wc2) "100 6"
set _permskill(wc3) "200 9"
set _permskill(wc4) "300 12"
set _permskill(wc5) "400 15"
set _permskill(wc6) "500 20"

set permskill(wh)   "{   } {           }"
set _permskill(wh1) "50 5"
set _permskill(wh2) "100 10"
set _permskill(wh3) "200 15"
set _permskill(wh4) "300 20"
set _permskill(wh5) "400 25"
set _permskill(wh6) "500 30"

set permskill(wl)   "{   } {         }"
set _permskill(wl1) "50 55"
set _permskill(wl2) "100 60"
set _permskill(wl3) "200 65"
set _permskill(wl4) "300 70"
set _permskill(wl5) "400 75"
set _permskill(wl6) "500 80"

set permskill(wd)   "{   } {     }"
set _permskill(wd1) "50 5"
set _permskill(wd2) "100 10"
set _permskill(wd3) "200 15"
set _permskill(wd4) "300 20"
set _permskill(wd5) "400 25"
set _permskill(wd6) "500 30"

set permskill(wm)   "{ } {         ,    ,       /}"
set _permskill(wm1) "50 5"
set _permskill(wm2) "100 10"
set _permskill(wm3) "200 15"
set _permskill(wm4) "300 20"
set _permskill(wm5) "400 25"
set _permskill(wm6) "500 30"

set permskill(wp)   "{ } {         ,    ,       /}"
set _permskill(wp1) "50 5"
set _permskill(wp2) "100 10"
set _permskill(wp3) "200 15"
set _permskill(wp4) "300 20"
set _permskill(wp5) "400 25"
set _permskill(wp6) "500 30"

proc mc:permskilltex {n uh h t} {
    global cth permskill thi
    
    set id [tolower [ms:fl $n]]
    if {![mc:check $id -]} { return }
    
    if {[llength $t] < 2} {
        mc:msg $n $cth(85fo)
        return
    }
    set thcode [tolower [lindex $t 1]]
    if {![info exists thi($thcode)]} {
        mc:msg $n $cth(8a)
        return
    }
    if {[mc:wget $thcode gskill] == "-"} {
        mc:msg $n $cth(85fp)
        return        
    }
    # requirements
    set reqout ""
    set price 0
    foreach req [mc:wget $thcode gprice] {
        set reqnum [lindex $req 0]
        set reqthi [lindex $req 1]
        set reqout [lappend reqout " 3$reqthi.[mc:wget $reqthi name] 14(10$reqnum14)04"]
        set price [expr $price + [mc:wget $reqthi price] * $reqnum]
    }    
    mc:msg $n [format $cth(85fq) [mc:wget $thcode name] [lindex $permskill([mc:wget $thcode gskill]) 0] [join $reqout ,] $price]
}

proc mc:permskilltmake {n uh h t} {
    global permskill _permskill cth thi mc

    set id [tolower [ms:fl $n]]
    if {![mc:check $id -]} { return }
    
    set namskill ""
    foreach permsk [mc:modget $id 51] {
        if {([lindex $permsk 0] == "gsm") || ([lindex $permsk 0] == "gjw")} {
            set namskill [lappend namskill $permsk]
        }
    }
    if {[llength $t] < 2} {
        mc:msg $n $cth(85fh)
        return
    }
    set thcode [tolower [lindex $t 1]]
    if {![info exists thi($thcode)]} {
        mc:msg $n $cth(8a)
        return
    }
    set isskill 0
    foreach skill $namskill {
        if {[mc:wget $thcode gskill] == [lindex $skill 0]} {
            if {[lindex $skill 1] == 0} {
                mc:msg $n [format $cth(85fg) [lindex $permskill([lindex $skill 0]) 0]]
                return
            }
            set isskill 1
            set namskill [lindex $skill 0]
            set useskill [lindex $skill 1]
        }
    }
    if {!$isskill} {
        mc:msg $n $cth(85fk)
        return        
    }
    if {[mc:modget $id 35] > 4} {
	    mc:msg $n [format $cth(85fr) 5]
	    return
    }
    if {[expr [mc:wget $thcode weight] + [mc:realweight $id]] > [mc:maxweight $id]} {
	    mc:msg $n $cth(85fs)
	    return
    }
    # requirements
    set tmpth [mc:modget $id 13]    
    set reqned ""
    set reqall 1
    foreach req [mc:wget $thcode gprice] {
        set reqnum [lindex $req 0]
        set reqthi [lindex $req 1]
        set idth13 ""
        foreach th $tmpth {
            if {[lindex $th 0] == $reqthi && $reqnum > 0} {
                set reqnum [expr $reqnum - 1]
            } else {
                set idth13 [lappend idth13 $th]
            }
        }
        if {$reqnum != 0} {
            set reqall 0
            set reqned [lappend reqned "$reqthi $reqnum"]
        }
        set tmpth $idth13
    }
    if {!$reqall} {
        set reqout ""
        foreach ned $reqned {
            set reqout [lappend reqout " 3[mc:wget [lindex $ned 0] name] 14(10[lindex $ned 1]14)04"]
        }
        mc:msg $n [format $cth(85fl) [join $reqout ,]]
        return
    }
    if {[mc:die 1d100] < [lindex $_permskill(${namskill}${useskill}) 1] && [mc:die 1d100] < [mc:wget $thcode gver]} {
        foreach pp [mc:modget $id 13] {
           set tarr([lindex $pp 1]) 1
        }
        set nn 0
        for {set i 0} {$i <= [array size tarr]} {incr i} {
           if {![info exist tarr($i)]} {
              set nn $i
              break
           }
        }
        set tmpth [lappend tmpth "$thcode $nn 0 {{$id [clock seconds]} 0}"]
        mc:mod $id 36 1
        mc:mod $id 35 1
        mc:notice $mc(notchan) "tmake: $n [mc:wget $thcode name] (succeded)"
        mc:msg $n [format $cth(85fn) [mc:wget $thcode name] $thcode $nn]
    } else {
	    mc:notice $mc(notchan) "tmake: $n [mc:wget $thcode name] (failed)"
        mc:msg $n [format $cth(85fm) [mc:wget $thcode name]]
    }
    mc:modset $id 13 $tmpth
}

proc mc:permskillcancast {id} {
    if {([mc:modget $id 16] == "m" && [lsearch -exact [mc:permskilleffect $id] "wm"] != -1) || ([mc:modget $id 16] == "p" && [lsearch -exact [mc:permskilleffect $id] "wp"] != -1)} {
        return 1
    } else {
        return 0
    }
}

proc mc:permskillmanareturn {id} {
    if {(([mc:modget $id 16] == "l" || [mc:modget $id 16] == "m") && [lsearch -exact [mc:permskilleffect $id] "wp"] != -1) || (([mc:modget $id 16] == "w" || [mc:modget $id 16] == "p") && [lsearch -exact [mc:permskilleffect $id] "wm"] != -1)} {
        return [mc:die 1d5]
    } else {
        return 0
    }
}

proc mc:permskillcanattack {id} {
    if {([mc:modget $id 16] == "l" && [lsearch -exact [mc:permskilleffect $id] "wm"] != -1) || ([mc:modget $id 16] == "w" && [lsearch -exact [mc:permskilleffect $id] "wp"] != -1)} {
        return 1
    } else {
        return 0
    }    
}

proc mc:permskilleffect {id} {
    global permskill _permskill
    
    set effectskills ""
    foreach sk [mc:modget $id 51] {
        if {([lindex $sk 0] == "wm" || [lindex $sk 0] == "wp") && ([isnumber [lindex $sk 1]] && [lindex $sk 1] > 0)} {
            if {[mc:die 1d100] < [lindex $_permskill([lindex $sk 0][lindex $sk 1]) 1]} {
                set effectskills [lappend effectskills [lindex $sk 0]]
            }
        }
    }
    return $effectskills
}

proc mc:permskilllearn {n uh h t} {
    global permskill _permskill cth
    
    set id [tolower [ms:fl $n]]
    if {![mc:check $id -]} {return}
    if {[info exists liv($id)]} { return } 

    if {[llength $t] < 2} {
        mc:msg $n $cth(85a)
        return
    }
    set permskillcode [tolower [lindex $t 1]]
    set ison 0
    set otherpskills ""
    foreach pskill [mc:modget $id 51] {
        if {[lindex $pskill 0] == $permskillcode} {
            set ison 1
            set foundskill $pskill
        } else {
            set otherpskills [lappend otherpskills $pskill]
        }
    }
    if {!$ison && [info exists permskill($permskillcode)]} {        
        set foundskill "$permskillcode 0"
        set ison 1
    }
    if {!$ison || ![info exists permskill($permskillcode)]} {
        mc:msg $n $cth(83b)
        return
    }

    if {[mc:modget $id 16] == "l" || [mc:modget $id 16] == "w"} {
        set bonind 28
    } else {
        set bonind 18
    }
    
    if {([lindex $foundskill 0] == "gsm") && ([mc:modget $id 16] == "p" || [mc:modget $id 16] == "m") || ([lindex $foundskill 0] == "gjw") && ([mc:modget $id 16] == "l" || [mc:modget $id 16] == "w")} {
        mc:msg $n $cth(85fu)
        return
    }

    if {[lindex $foundskill 1] < 6} {
        if {[mc:modget $id $bonind] < [lindex $_permskill(${permskillcode}[expr [lindex $foundskill 1] + 1]) 0]} {
            mc:msg $n [format $cth(85c) [expr [lindex $_permskill(${permskillcode}[expr [lindex $foundskill 1] + 1]) 0]  - [mc:modget $id $bonind]]]
            return
        } else {
            set nextpskilllevel [expr [lindex $foundskill 1] + 1]
            set foundskill [lreplace $foundskill 1 1 $nextpskilllevel]
            set pskillen [lindex $_permskill(${permskillcode}$nextpskilllevel) 0]
            mc:mod $id $bonind -$pskillen
            mc:modset $id 51 [lappend otherpskills $foundskill]
            mc:msg $n [format $cth(85d) [lindex $permskill($permskillcode) 0] $nextpskilllevel $pskillen]
            return
        }
    } else {
        mc:msg $n $cth(85b)
        return
    }
}

proc mc:permskilllist {n uh h t} {
    global permskill _permskill cth
    
    set id [tolower [ms:fl $n]]
    if {![mc:check $id -]} { return }
    
    set out ""
    foreach permsk [mc:modget $id 51] {
        if {[info exists permskill([lindex $permsk 0])]} {
            set out "$out[format $cth(84a) [lindex $permsk 0] [lindex $permskill([lindex $permsk 0]) 0] [lindex $permsk 1]]"
        }
    }
    if {$out != ""} {
        mc:msg $n [format $cth(84) $out]
    }
}

proc mc:permskillex {n uh h t} {
    global permskill _permskill cth
    
    set id [tolower [ms:fl $n]]
    if {![mc:check $id -]} { return }
    if {[llength $t] < 2} {
        mc:msg $n $cth(83a)
        return
    }
    set permskillcode [lindex $t 1]
    if {![info exists permskill($permskillcode)]} {
        mc:msg $n $cth(83b)
        return
    }
    mc:msg $n [format $cth(83c) [lindex $permskill($permskillcode) 0] [lindex $permskill($permskillcode) 1] [lindex $_permskill(${permskillcode}1) 0] [lindex $_permskill(${permskillcode}1) 1] [lindex $_permskill(${permskillcode}2) 0] [lindex $_permskill(${permskillcode}2) 1] [lindex $_permskill(${permskillcode}3) 0] [lindex $_permskill(${permskillcode}3) 1] [lindex $_permskill(${permskillcode}4) 0] [lindex $_permskill(${permskillcode}4) 1] [lindex $_permskill(${permskillcode}5) 0] [lindex $_permskill(${permskillcode}5) 1] [lindex $_permskill(${permskillcode}6) 0] [lindex $_permskill(${permskillcode}6) 1]]
}
