#      $regcom (teamlimit  mcomget 6)
proc mc:maxplayersincom {regcom} {
  global mcr mc ct mcc mco
   
  if {[array exists mcr] && [array exists mcc]} {
    set altplr 0
    foreach e [array names mcr] {
       if {$mcr($e) == $regcom} { incr altplr }
    }
    if {[info exists mcc($regcom] && [info exists mco($mcc($regcom))]} {
       set maxpl [mc:mcomget [mc:comid $mcc($regcom)] 6]
       if {$maxpl > 0 && $altplr >= $maxpl} {
          return 1
       }
    }
    if {$altplr >= $mc(teamlimit)} {
        return 1
    }
  }
  return 0  
}

proc mc:pteamlimit {n uh h c t} {
  global mcs mc ct mcr mcc mce rnam
  
#  if {![isop $n $mc(chan)]} { return }
  
  if {[llength $t] > 1} {
   set ll [lindex [ms:fl $t] 1]
   if {[isnumber $ll]} {
     set mc(teamlimit) $ll
   }
  }
  mc:tsay $n "     $mc(teamlimit) "
}

proc mc:plimit {n uh h c t} {
  global mcs mc ct mcr mcc mce rnam

#  if {![isop $n $mc(chan)]} { return }
  
  if {[llength $t] > 1} {
      set ll [lindex [ms:fl $t] 1]
    if {[isnumber $ll]} {
      set mc(limit) $ll
    }
  }
  mc:tsay $n "[format $ct(11b) $mc(limit)]"
}

proc mc:startregext {} {
  global needtobeopped noreg mc
  
  if {[info exists needtobeopped]} { unset needtobeopped }
  set noreg 0
  if {$mc(moderating) == 1} {
     bots:unmoderate
  }
  mc:notice $mc(notchan) ",  !"
}

proc mc:startreg {} {
  global mc ct noreg tleft
  global needtobeopped
                
  putcmdlog "REGSTART"
  mc:startregext
  set rand [rand 5]
  mc:say [mc:randchars $ct(reg$rand)]  
  utimer [expr 60 * $mc(regtime)] { mc:rpstart reg_timer }
  if {[info exists tleft]} { unset tleft }
  utimer 60 { mc:rptimeleft reg_timer }
}

proc mc:pstartreg {n uh h c t} {
  global mc ct noreg tleft

#  if {![isop $n $mc(chan)]} { return }

  putcmdlog "!startreg"
  mc:startregext
  cleartimers
  set rand [rand 5]
  set mc(phase) 0
  mc:say [mc:randchars $ct(reg$rand)]
  utimer [expr 60 * $mc(regtime)] { mc:rpstart reg_timer }
  if {[info exists tleft]} { unset tleft }
  utimer 60 { mc:rptimeleft reg_timer }
}

proc mc:rptimeleft {t} {
  global mcs mc ct mcr mcc mce tleft

  if {![istimer reg_timer]} { return }
  if {![info exists tleft]} { 
     set tleft [expr $mc(regtime) - 1] 
  } else { 
     set tleft [expr $tleft - 1] 
  }
  set ost ""
  set min $tleft
  if {$tleft<=1} {
     set min 1
     set ost ""
     set minx ""
  } elseif {$tleft<5} {
     set minx ""
  } else {
     set minx ""
  }
  mc:say "   $ost $min $minx"
  mc:checkcomm
  utimer 60 { mc:rptimeleft reg_timer }
}

proc mc:rpstart {t} {
  global mcs mc ct mcr mcc mce
  global tregbans

  if {$mc(phase) != 0} { return }

  cleartimers
  if {(![array exists mce]) || ([array size mce] < 2)} {
    mc:say $ct(18a)
#   utimer 300 { mc:rpstart reg_timer }
    return
  }

  set comm(0) 0
  set allcom 0
  foreach cc [array names mcr] {
    if {[info exist comm($mcr($cc))]} {
      incr comm($mcr($cc)) [mc:modget $cc 17]
    } else {
      set comm($mcr($cc)) [mc:modget $cc 17]
    }
    incr allcom [mc:modget $cc 17]
  }
  foreach cc [array names comm] {
    if {[array exists mcr] && [array size mcr] > 10} {
       set pplkoef 2
    } elseif {[array exists mcr] && [array size mcr] > 5} {
       set pplkoef 1
    } else {
       set pplkoef 0
    }
    if {$comm($cc) > [expr ($allcom - $comm($cc)) + $pplkoef]} {
       foreach nn [array names mcr] {
           if {$mcr($nn) == $cc} {
              mc:say [format $ct(18c) [ms:dfl [mc:modget [ms:dfl $nn] 0]]]
#             if {![array exists tregbans]} { set tregbans(0) "" }
#             set tregbans($nn) [expr [clock seconds] + 40]
#             utimer 40 { mc:clrtban }
              mc:punreg $nn "" "" "" ""
              return
           }
       }
    }
  }
  utimer 30 { mc:pstart "" "" "" "" "" }
}

proc mc:clrtban {} {
    global tregbans

    if {![array exists tregbans]} { set tregbans(0) "" }
    foreach ban [array names tregbans] {
       if {$tregbans($ban) <= [clock seconds]} { unset tregbans($ban) }
    }
}

proc mc:preg {n uh h c t} {
    global mcs mc ct mcr mcc mce rnam noreg mco cto mctn
    global tregbans uhosts cth needtobeopped

    set id [tolower [ms:fl $n]]
    if {[info exists noreg] && $noreg == 1} { return }
    if {[info exists tregbans($id)] && $tregbans($id)} {
       mc:say [format $ct(11c) $n]
       return
    }
    if {![info exists mcs($id)]} {
        mc:tsay $n "$ct(10)"
        return
    }
    if {![mc:check $id 0]} { return }
    set ondcc 0
    foreach nn [array names mctn] {
        if {$mctn($nn) == $id} {
            set ondcc 1
        }
    }

    set needtobevoiced 0
    set rteaml 0
    set mcrstr ""
    set mctnstr ""
    foreach idr [array names mcr] { set mcrstr "$mcrstr $idr" }
    foreach idr [array names mctn] { set mctnstr "$mctnstr $idr" }
#    putcmdlog "-----"
#    putcmdlog "limit = |$mc(limit)| ondcc = |$ondcc|"
#    putcmdlog "!REG BEF <$n>"
#    putcmdlog "mcr   = |$mcrstr|"
#    putcmdlog "mctn  = |$mctnstr|"
#    putcmdlog "sof1  = |[llength $mcrstr]| sof2 = |[llength $mctnstr]|"
#    putcmdlog "size1 = |[array size mcr]| size1 = |[array size mctn]|"

    #     
    if {[array exists mcr] && [info exists mcr($id)] && ([llength $t] == 1)} {
#        putquick "KICK $c $n
#        mc:tsay $n [format $ct(11) [mc:delcom $mcc($mcr($id))]]
        return
    } elseif {[array exists mcr] && [info exists mcr($id)] && ([array size mcr] < $mc(limit) || [info exist mcr($id)])} {
        unset mcr($id)
        unset mce($id)
        if {[array size mcr] == 0} {
            unset mcr
            unset mce
            unset mcc
        } else {
            foreach e [array names mcr] {
                set ttmm($mcr($e)) 1
            }
            foreach e [array names mcc] {
                if {![info exists ttmm($e)]} {
                    unset mcc($e)
                }
            }
        }
    } elseif {[array exist mcr] && [array size mcr] >= $mc(limit)} {
#        mc:tsay $n [format $ct(11a) $mc(limit)]
#        putcmdlog "(ondcc == 0)"
        return
    } else {
        set needtobevoiced 1
#       pushmode $mc(chan) +v $n
    }
    icleartimers
    set regcom ""
    #   
    if {![array exists uhosts]} { set uhosts(0) "" }
    regsub -all "^.*@" $uh "" userhost
    foreach uhs [array names uhosts] {
        if {$uhosts($uhs) == $userhost && $uhs != $id && ![mc:isonanicklist $id [ms:fl $userhost]]} {
            mc:say [format $cth(82ga) $n $userhost]
            mc:notice $n $cth(82gb)
            return
        }
    }
    set uhosts($id) $userhost
    if {[array exists mcc]} {
        #    
        set maxcom 1
        foreach nn [array names mcc] {
            if {[expr $nn + 1] > $maxcom} { set maxcom [expr $nn + 2] }
        }
        #       
        set mostcom 1
        for {set i 1} {$i <= $maxcom} {incr i} {
            if {![info exist mcc($i)]} {
                set mostcom $i
                break
            }
        }
    } else {
        set maxcom 1
        set mostcom 1
    }
    if {[llength $t] == 1} {
        if {[array exists mcc]} {
            foreach e [array names mcc] {
                if {[mc:comid [mc:modget $id 2]] == [mc:comid $mcc($e)]} {
                    set regcom $e
                    break
                }
            }
        }
        #    ,    
        if {$regcom == ""} {
            set regcom $mostcom
        }
    } else {
        set tmpcom [string trimleft [lindex $t 1] 0]
        if {![isnumber $tmpcom] || $tmpcom < 1 || $tmpcom > $maxcom} {
            mc:tsay $n $ct(12)
            return
        }
        set regcom $tmpcom
    }
    set toreg ""
    if {[array exist mcc] && [info exist mcc($regcom)]} {
        set toreg $mcc($regcom)
    } elseif {[mc:modget $id 2] != "-"} {
        set toreg [mc:modget $id 2]
    }
    #    
    if {[mc:maxplayersincom $regcom]} {
       mc:tsay $n [format $ct(13d) $toreg]
       set regcom $mostcom
       set toreg ""
       set rteaml 1
    }
    # //
    if {$toreg != "" && [info exist mco([mc:comid $toreg])]} {
        set cid [mc:comid $toreg]
        set ac [mc:comga $cid $id]
        if {([mc:mcomget $cid 4] == 1 && $ac < 1) || $ac < 0} {
            mc:tsay $n [format $cto(0a) [mc:mcomget $cid 0]]
            return
        }
    }
    if {![array exists mcc] || ([array exists mcc] && ![info exists mcc($regcom)])} {
        #       
        if {[mc:modget $id 2] != "-" && $rteaml == 1} {
            set tmc [mc:modget $id 2]
            if {[info exist mco([mc:comid $tmc])]} {
               set tmc [mc:mcomget [mc:comid $tmc] 0]
            }
            #   ?
            set ison 0            
            set isonm 0
            foreach e [array names mcc] {
               if {[mc:comid [mc:modget $id 2]] == [mc:comid $mcc($e)] && ![mc:maxplayersincom $e]} {
                   set regcom $e
                   set ison 1                   
                   break
               } elseif {[mc:comid [mc:modget $id 2]] == [mc:comid $mcc($e)]} {
                   set ison 1
                   set isonm 1
               }
            }
            if {$ison && $isonm} {
               set mcc($regcom) ".$regcom"
            } elseif {!$ison} {
               set mcc($regcom) $tmc
            }
        # //
        } elseif {[mc:modget $id 2] != "-"} {
            set tmc [mc:modget $id 2]
            if {[info exist mco([mc:comid $tmc])]} {
                set tmc [mc:mcomget [mc:comid $tmc] 0]
            }
            set mcc($regcom) $tmc
        } else {
            set mcc($regcom) ".$regcom"
        }
    }
    if {[mc:modget $id 41] == ""} { set mcs($id) [linsert $mcs($id) end " "] }
    if {[mc:modget $id 42] == ""} { set mcs($id) [linsert $mcs($id) end " "] }
    if {[mc:modget $id 43] == ""} { set mcs($id) [linsert $mcs($id) end " "] }

    set mcr($id) $regcom
    set mce($id) 1

    #"12%s14\(10%s14/10%s 06l:%s14\) 10   14<%s14> 14\(10%s14\)"
    #<><><>(</> l:<>)    <_> (<_>)

    set output ""

    # 
    if {$mc(sptitles) == 1 && ([mc:modget $id 43] != " " && ([mc:modget $id 17] >= 5 || [mc:modget $id 30] > 0))} {
        set output "$output10[mc:modget $id 43] "
    }
    set output "$output12$n"

    # 
    if {$mc(stitles) == 1 && ([mc:modget $id 42] != " " && ([mc:modget $id 17] >= 1 || [mc:modget $id 30] > 0))} {
        set output "$output10[mc:modget $id 42]"
    }
    set output "$output 14\("

    # /
    if {$mc(sraces) == 1 && [mc:modget $id 41] != " " && ([mc:modget $id 17] >= 1 || [mc:modget $id 30] > 0)} {
        set output "$output[mc:modget $id 41]"
    } else {
	    if {[mc:modget $id 33] == "-"} {
            set output "$output10$rnam([mc:modget $id 16])"
        } else {
	        set output "$output10$rnam([mc:modget $id 33][mc:modget $id 16])"
        }
    }

#    set output "$output 06l:[mc:modget $id 17]14\) 10   14< [mc:delcom [ms:dfl $mcc($regcom)]] 14> \(10$regcom14\)"
    set output [xformat $ct(14a) [mc:modget $id 21] "{[stripspec $output]} {[mc:modget $id 17]} {[stripspec [mc:delcom [ms:dfl $mcc($regcom)]]]} {$regcom}"]
    if {$needtobevoiced} {
       if {$mc(deop) && [isop $n $mc(chan)]} {
           if {![info exists needtobeopped]} { set needtobeopped "" }
           if {[lsearch -exact $needtobeopped [tolower [ms:fl $n]]] == -1} {
              set needtobeopped [lappend needtobeopped [tolower [ms:fl $n]]]
           }
           bots:deop $n
       }
       bots:voice $n       
    }
    mc:say $output

    set mcrstr ""
    set mctnstr ""
    foreach idr [array names mcr] { set mcrstr "$mcrstr $idr" }
    foreach idr [array names mctn] { set mctnstr "$mctnstr $idr" }
#    putcmdlog "-----"
#    putcmdlog "!REG AFT <$n>"
#    putcmdlog "mcr   = |$mcrstr|"
#    putcmdlog "mctn  = |$mctnstr|"
#    putcmdlog "sof1  = |[llength $mcrstr]| sof2 = |[llength $mctnstr]|"
#    putcmdlog "size1 = |[array size mcr]| size1 = |[array size mctn]|"

    if {[array size mcr] >= $mc(limit)} {
#        putcmdlog "0,4FULL LIMIT"
        mc:say [format $ct(11a) $mc(limit)]
    }
    if {![istimer reg_timer]} { utimer 30 { mc:rpstart reg_timer } }
    mc:checkcomm
}

proc mc:punreg {n uh h c t} {
  global mcs mc ct mcr mcc mce uhosts needtobeopped

  if {$mc(phase) != 0} {return}
  set id [tolower [ms:fl $n]]

  if {![info exists mcs($id)]} {
    mc:tsay $n $ct(10)
    return
  }
  if {[array exists mcr] && [info exists mcr($id)]} {
    if {[info exists uhosts($id)]} { unset uhosts($id) }
    mc:tsay $n [format $ct(14) [mc:delcom [ms:dfl $mcc($mcr($id))]]]
    bots:devoice $n
    if {[info exists needtobeopped] && [lsearch -exact $needtobeopped $id] != -1 && ![isop $n $mc(chan)]} {
        bots:op $n
        set opind [lsearch -exact $needtobeopped $id]
        set needtobeopped [lreplace $needtobeopped $opind $opind]
    }
    unset mcr($id)
    unset mce($id)
    icleartimers
    if {![istimer reg_timer]} { utimer 30 { mc:rpstart reg_timer } }
    mc:checkcomm
    if {[array size mcr] == 0} {
      unset mcr
      unset mce
      unset mcc
    } else {
      foreach e [array names mcr] {
        set ttmm($mcr($e)) 1
      }
      foreach e [array names mcc] {
        if {![info exists ttmm($e)]} {
          unset mcc($e)
        }
      }
    }
  }
}

proc mc:pcom {n uh h c t} {
  global mcs mc ct mcr mcc mce lastcom

  if {$mc(phase) < 1} {
    mc:pcom1 $n $uh $h $c $t
  } elseif {$mc(phase) != 0} {
    mc:pcom2 $n $uh $h $c $t
  } else {
    return
  }
}

#  
proc mc:pcom1 {n uh h c t} {
  global mcs mc ct mcr mcc mce lastcom
  if {$mc(phase) != 0} { return }
  bots:say $n [join $t]
  if {[info exist lastcom] && ($lastcom > [clock seconds])} {
     return
  }
  if {[array exists mcr]} {
    foreach e [array names mcr] {
      if {$mce($e)} {
        set tmpnick "[mc:nick $e]"
      } else {
        set tmpnick "[mc:nick $e]"
      }
      if {[info exists ttmm($mcr($e))]} {
        set ttmm($mcr($e)) [lappend ttmm($mcr($e)) $tmpnick]
      } else {
        set ttmm($mcr($e)) $tmpnick
      }
    }
    set coms "12:"
    foreach e [array names ttmm] {
      set nextteam [join $ttmm($e) ", "]
      set nexttname [mc:delcom [string trimright $mcc($e) 10]]
      if {[expr [string length $coms]+[string length $nextteam]+[string length $nexttname]] > 320} {
        mc:say $coms
        set coms "12:"
      }
      #set coms "$coms [ms:dfl "06$e.14\[[mc:delcom [string trimright $mcc($e) 10]]14\]10 [join $ttmm($e) "14,10 "]\;"]"
      set coms "$coms [ms:dfl "06$e.14\[$nexttname14\]10 $nextteam\;"]"
    }
    mc:say $coms
  } else {
    mc:tsay $n $ct(16)
  }
  set lastcom [expr [clock seconds] + 30]
}

#   
proc mc:pcom2 {n uh h c t} {
  global mcs mc ct mcr mcc mce liv nnick prc lastcom
  if {$mc(phase) < 1} { return }
  bots:say $n [join $t]
  if {[info exist lastcom] && ($lastcom > [clock seconds])} {
    return
  }
  if {[array exists liv]} {
    foreach e [array names liv] {
      if {($prc($e) == 0) && ($mc(phase) == 1)} {
        set tmpnick "$nnick($e)"
      } else {
        set tmpnick "$nnick($e)"
      }
      if {[info exists ttmm($mcr($e))]} {
        set ttmm($mcr($e)) [lappend ttmm($mcr($e)) $tmpnick]
      } else {
        set ttmm($mcr($e)) $tmpnick
      }
    }
    set coms "12:"
    foreach e [array names ttmm] {
      set nextteam [join $ttmm($e) ", "]
      set nexttname [mc:delcom [string trimright $mcc($e) 10]]
      if {[expr [string length $coms]+[string length $nextteam]+[string length $nexttname]] > 320} {
        mc:say $coms
        set coms "12:"
      }
      #set coms "$coms [ms:dfl "14\[[mc:delcom [string trimright $mcc($e) 10]]14\]10 [join $ttmm($e) "14,10 "]\; "]"
      set coms "$coms [ms:dfl "14\[$nexttname14\]10 $nextteam\;"]"
    }
    mc:say $coms
  } else {
    mc:tsay $n $ct(16)
  }
  set lastcom [expr [clock seconds] + 60]
}

proc mc:pmoves {n uh h c t} {
  global mcs mc ct mcr mcc mce lastcom

  if {$mc(phase) < 1} {
#izm
#    mc:pmoves1 $n $uh $h $c $t
#izm
  } elseif {$mc(phase) != 0} {
    mc:pmoves2 $n $uh $h $c $t
  } else {
    return
  }
}

#  
proc mc:pmoves1 {n uh h c t} {
  global mcs mc ct mcr mcc mce liv nnick prc lastmoves

  if {[info exist lastmoves] && ($lastmoves > [clock seconds])} { return }
  bots:say $n [join $t]
  if {[array exists mcr]} {
    foreach e [array names mcr] {
      set tmpnick ""
      if {!$mce($e)} { set tmpnick "[mc:nick $e]" }
      if {[info exists ttmm($mcr($e))]} {
        set ttmm($mcr($e)) [join [lappend ttmm($mcr($e)) $tmpnick]]
      } else {
        set ttmm($mcr($e)) $tmpnick
      }
    }
    set coms "12 :"
    foreach e [array names ttmm] {
      set nextteam [join $ttmm($e) ", "]
      set nexttname [mc:delcom [string trimright $mcc($e) 10]]
      if {[expr [string length $coms]+[string length $nextteam]+[string length $nexttname]] > 390} {
        mc:say $coms
        set coms "12 :"
      }
      if {$ttmm($e) != ""} {
        #set coms "$coms [ms:dfl "06$e.14\[[mc:delcom [string trimright $mcc($e) 10]]14\]10 [join $ttmm($e) ", "]\;"]"
        set coms "$coms [ms:dfl "06$e.14\[$nexttname14\]10 $nextteam\;"]"
      }
    }
    if {[llength $coms] >= 3} { mc:say $coms
    } else { mc:say "10    ." }
  } else {
    mc:tsay $n $ct(16)
  }
  set lastmoves [expr [clock seconds] + 30]
}

#   
proc mc:pmoves2 {n uh h c t} {
  global mcs mc ct mcr mcc mce liv nnick prc lastmoves

  if {[info exist lastmoves] && ($lastmoves > [clock seconds])} { return }
  bots:say $n [join $t]
  if {[array exists liv]} {
    foreach e [array names liv] {
      set tmpnick ""
      if {($prc($e) != 0) && ($mc(phase) == 1)} { set tmpnick "$nnick($e)" }
      if {[info exists ttmm($mcr($e))]} {
        set ttmm($mcr($e)) [join [lappend ttmm($mcr($e)) $tmpnick]]
        #set ttmm($mcr($e)) "$ttmm($mcr($e)), $tmpnick"
      } else {
        set ttmm($mcr($e)) $tmpnick
      }
    }
    set coms "12 :"
    foreach e [array names ttmm] {
      set nextteam [join $ttmm($e) ", "]
      set nexttname [mc:delcom [string trimright $mcc($e) 10]]
      if {[expr [string length $coms]+[string length $nextteam]+[string length $nexttname]] > 390} {
        mc:say $coms
        set coms "12 :"
      }
      if {$ttmm($e) != ""} {
        #set coms "$coms [ms:dfl "14\[[mc:delcom [string trimright $mcc($e) 10]]14\]10 [join $ttmm($e) ", "]\;"]"
        set coms "$coms [ms:dfl "14\[$nexttname14\]10 $nextteam\;"]"
      }
    }
    if {[llength $coms] >= 3} { mc:say $coms
    } else { mc:say "10   ." }
  } else {
    mc:tsay $n $ct(16)
  }
  set lastmoves [expr [clock seconds] + 30]
}

proc mc:pname {n uh h c t} {
  global mcs mc ct mcr mcc mce mco
  if {$mc(phase) != 0} { return }
  set id [tolower [ms:fl $n]]
  if {[llength $t] < 2} { return }
  if {[array exists mcr] && [info exists mcr($id)]} {
    set tcomm "[mc:delcom [lrange [ms:fl $t] 1 end]]10"
# akhkharu (  !comset chn)
    set cid [mc:comid $mcc($mcr($id))]
    if {[info exist mco($cid)] && [mc:comga $cid $id] <= 50} {
     if {[mc:mcomget $cid 5]} {
      mc:say [format $ct(13b) $mcr($id)]
      return
     }
    }
    set cid [mc:comid $tcomm]
    if {[info exist mco($cid)]} {
     if {[mc:mcomget $cid 4] && [mc:comga $cid $id] <= 50} {
      mc:say [format $ct(13c) $mcr($id)]
      return
     }
    }
#//
    bots:say $n [join $t]
    mc:say [format $ct(13a) $mcr($id) [mc:delcom [ms:dfl $mcc($mcr($id))]] [ms:dfl $tcomm]]
    set mcc($mcr($id)) $tcomm
  } else {
    bots:say $n [join $t]
    mc:tsay $n $ct(15)
  }
}

proc mc:pready {n uh h c t} {
  global mcs mc ct mcr mcc mce

  if {$mc(phase) != 0} { return }
  set id [tolower [ms:fl $n]]

  if {![array exists mcr] || ![info exists mcr($id)]} {
    mc:tsay $n $ct(15)
    return
  }
  if {$mce($id)} { return }
  icleartimers
  set mce($id) 1
  mc:say [xformat $ct(17) [mc:modget $id 21] "{[stripspec $n]}"]
  mc:checkcomm
}

proc mc:punready {n uh h c t} {
  global mcs mc ct mcr mcc mce

  if {$mc(phase) != 0} { return }
  set id [tolower [ms:fl $n]]

  if {![array exists mcr] || ![info exists mcr($id)]} {
    mc:tsay $n $ct(15)
    return
  }
  if {$mce($id)} {
    icleartimers
    set mce($id) 0
    mc:say [xformat $ct(17b) [mc:modget $id 21] "{[stripspec $n]}"]
    mc:checkcomm
  }

}

proc mc:pclear {n uh h c t} {
  global mcs mc ct mcr mcc mce

#  if {![isop $n $mc(chan)]} { return }
  
  if {$mc(phase) != 0} { return }
  if {[array exists mcc]} { unset mcc }
  if {[array exists mcr]} { unset mcr }
  if {[array exists mce]} { unset mce }
}

proc mc:checkcomm {} {
  global mcs mc ct mcr mcc mce
  if {$mc(phase) != 0} { return }

# icleartimers
  if {(![array exists mce]) || ([array size mce] < 2)} {
    mc:say $ct(18a)
    return
  }
# foreach e [array names mce] {
#   if {!$mce($e)} {
#      mc:say $ct(18)
#     utimer 30 { mc:checkcomm }
#     return
#   }
# }
  set comm(0) 0
  set allcom 0
  foreach cc [array names mcr] {
    if {[info exist comm($mcr($cc))]} {
      incr comm($mcr($cc)) [mc:modget $cc 17]
    } else {
      set comm($mcr($cc)) [mc:modget $cc 17]
    }
    incr allcom [mc:modget $cc 17]
  }
  foreach cc [array names comm] {
    if {[array exists mcr] && [array size mcr] > 10} {
       set pplkoef 2
    } elseif {[array exists mcr] && [array size mcr] > 5} {
       set pplkoef 1
    } else {
       set pplkoef 0
    }
    if {$comm($cc) > [expr ($allcom - $comm($cc)) + $pplkoef]} {
      mc:say [format $ct(18b) [ms:dfl [mc:delcom $mcc($cc)]]]
#     utimer 30 { mc:checkcomm }
      return
    }
  }
# utimer 60 { mc:pstart n uh h c t }
}

proc mc:pmstart {n uh h c t} {
	global mc
	
#    if {![isop $n $mc(chan)]} { return }
	
	mc:pstart $n $uh $h $c $t
}

proc mc:pstart {n uh h c t} {
  global mcs mc ct mcr mcc mce min ts tl ti tm tv th ta tae tg te todo liv param nnick prc hitten countr countt
  global noreg endround uhosts roundcount qcntr poifail poitnd roundlenght rdeath tregbans lastroundkilled

  set qcntr 0
  set noreg 1
  if {[array exists tg]} { unset tg }
  if {[array exists liv]} { unset liv }
  if {[array exists uhosts]} { unset uhosts }
  if {[array exists ghost]} { unset ghost }
  if {[array exists tregbans]} { unset tregbans }
  if {[info exists endround]} { unset endround }

  cleartimers
  mc:say $ct(19)
  mc:checkvoices
  
  set mc(phase) 1
  set countr 0
  set countt [unixtime]
  set tg(0) ""
   foreach e [array names mcr] {
	  set harks [mc:addharks $e]
	  set ts($e) [lindex $harks 5]
	  set tl($e) [lindex $harks 6]
	  set ti($e) [lindex $harks 7]
	  set tm($e) [lindex $harks 8]
	  set tv($e) [lindex $harks 9]
	  set th($e) [lindex $harks 1]
	  set ta($e) [lindex $harks 2]
	  set tae($e) [lindex $harks 3]
	  set tg($e) [lindex $harks 0]
	  set te($e) [lindex $harks 4]
      set todo($e) ""
      set prc($e) 100
      set liv($e) 1
      set param($e) ""
      set nnick($e) [mc:nick $e]
  }
  mc:setmsgmode
  set hitten 0
  if {[info exists poifail]} { unset poifail }
  if {[info exists poitnd]} { unset poitnd }
  set rdeath 0
  set lastroundkilled ""
  mc:start
}